/*  TA3D, a remake of Total Annihilation
    Copyright (C) 2006  Roland BROCHARD

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

/*
**  File: TA3D_Exception.cpp
** Notes:
**   Cire: See notes in TA3D_Exception.h
*/
#include "stdafx.h"
#include "TA3D_Exception.h"

namespace TA3D
{
   namespace EXCEPTION
   {
      static bool ExceptionStatus = false;
      static uint32 IndentLevel = 0;

      bool IsExceptionInProgress (void)
      {
         return (ExceptionStatus);
      }

      void SetExceptionStatus (bool E)
      {
         ExceptionStatus = E;
         return;
      }

      void IncrementIndent (void)
      {
         IndentLevel++;
         return;
      }

      void DecrementIndent (void)
      {
         if (IndentLevel != 0)
            IndentLevel--;

         return;
      }

      uint32 GetIndentLevel (void)
      {
         return (IndentLevel);
      }

#ifdef TA3D_PLATFORM_WINDOWS
      void __cdecl ThrowFatal( const char *Format, ... )
#else
      void ThrowFatal( const char *Format, ... )
#endif
      {
         char    Buffer[2000];
         String  BufferToss;
         va_list marker;

         va_start (marker, Format);
         vsprintf (Buffer, Format, marker);
         va_end (marker);

         dprintf ("Throwing error string -> %s\n", Buffer);
         BufferToss = String(Buffer);
         SetExceptionStatus (true);
         throw (BufferToss);

         return;
      }

      // TODO: output to global debugger.
#ifdef TA3D_PLATFORM_WINDOWS
      void __cdecl GlobalDebuggerPrintf (const char *Format, ...)
#else
      void GlobalDebuggerPrintf (const char *Format, ...)
#endif
      {
         char    Buffer[2000];
         va_list marker;

      //   if (GlobalDebugger == NULL)
      //      return;

         va_start (marker, Format);
         vsprintf (Buffer, Format, marker);
         va_end (marker);

      //   GlobalDebugger->DebugPrintf (Buffer);

         return;
      }
   } // namespace EXCEPTION
} // namespace TA3D
