/*  TA3D, a remake of Total Annihilation
    Copyright (C) 2005  Roland BROCHARD

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

/*---------------------------------------------------------------------------------\
|                                        gui.cpp                                   |
|         Contient les fonctions nécessaires à la gestion de l'interface de ta3D   |
|  comme les boutons, les fenêtres,...                                             |
|                                                                                  |
\---------------------------------------------------------------------------------*/

#ifdef CWDEBUG
#include <libcwd/sys.h>
#include <libcwd/debug.h>
#endif
#include "stdafx.h"
#include "matrix.h"
#include "TA3D_NameSpace.h"
#include "ta3dbase.h"

void glbutton(char *caption,float x1,float y1,float x2,float y2,bool etat)
{
	glDisable(GL_TEXTURE_2D);

	glBegin(GL_QUADS);
	if(!etat) {
		glColor3f(1.0f,1.0f,1.0f);	glVertex2f(x1,y1);			// Dessine les bords du bouton
		glColor3f(0.5f,0.5f,0.5f);	glVertex2f(x2,y1);
		glColor3f(0.0f,0.0f,0.0f);	glVertex2f(x2,y2);
		glColor3f(0.5f,0.5f,0.5f);	glVertex2f(x1,y2);
		}
	else {
		glColor3f(0.0f,0.0f,0.0f);	glVertex2f(x1,y1);			// Dessine les bords du bouton
		glColor3f(0.5f,0.5f,0.5f);	glVertex2f(x2,y1);
		glColor3f(1.0f,1.0f,1.0f);	glVertex2f(x2,y2);
		glColor3f(0.5f,0.5f,0.5f);	glVertex2f(x1,y2);
		}

		glVertex2f(x1+2,y1+2);			// Dessine le fond du bouton
		glVertex2f(x2-2,y1+2);
		glVertex2f(x2-2,y2-2);
		glVertex2f(x1+2,y2-2);
	glEnd();

	glEnable(GL_TEXTURE_2D);

	glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_COLOR);
	glEnable(GL_BLEND);
	if(etat)
		allegro_gl_printf(aglfont,0.5f*(x1+x2-9*strlen(caption))+1.0f,0.5f*(y1+y2-9.0f)+1.0f,0.0f,0xFFFFFF,caption);
	else
		allegro_gl_printf(aglfont,0.5f*(x1+x2-9*strlen(caption)),0.5f*(y1+y2-9.0f),0.0f,0xFFFFFF,caption);
	glDisable(GL_BLEND);
}

char *msg_box(FONT *fnt,char *title,char *msg,bool ask)
{
	allegro_gl_set_allegro_mode();
	for(int i=0;i<2;i++) {
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glColor4f(0.5f,0.5f,0.5f,1.0f);
	glBegin(GL_QUADS);
		glVertex2i(SCREEN_W>>2,SCREEN_H>>2);
		glVertex2i(SCREEN_W*3>>2,SCREEN_H>>2);
		glVertex2i(SCREEN_W*3>>2,SCREEN_H*3>>2);
		glVertex2i(SCREEN_W>>2,SCREEN_H*3>>2);
	glEnd();
	glBegin(GL_LINES);
		glColor4f(1.0f,1.0f,1.0f,1.0f);
		glVertex2i(SCREEN_W>>2,SCREEN_H>>2);		glVertex2i(SCREEN_W*3>>2,SCREEN_H>>2);
		glVertex2i(SCREEN_W>>2,SCREEN_H>>2);		glVertex2i(SCREEN_W>>2,SCREEN_H*3>>2);

		glColor4f(0.25f,0.25f,0.25f,1.0f);
		glVertex2i(SCREEN_W*3>>2,SCREEN_H*3>>2);	glVertex2i(SCREEN_W>>2,SCREEN_H*3>>2);
		glVertex2i(SCREEN_W*3>>2,SCREEN_H*3>>2);	glVertex2i(SCREEN_W*3>>2,SCREEN_H>>2);
	glEnd();
	glBegin(GL_QUADS);
		glColor4f(0.3f,0.3f,1.0f,1.0f);
		glVertex2i((SCREEN_W>>2)+3,(SCREEN_H>>2)+3);
		glColor4f(0.7f,0.7f,1.0f,1.0f);
		glVertex2i((SCREEN_W*3>>2)-3,(SCREEN_H>>2)+3);
		glVertex2i((SCREEN_W*3>>2)-3,(SCREEN_H>>2)+3+text_height(fnt));
		glColor4f(0.3f,0.3f,1.0f,1.0f);
		glVertex2i((SCREEN_W>>2)+3,(SCREEN_H>>2)+3+text_height(fnt));
	glEnd();
	glEnable(GL_TEXTURE_2D);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	allegro_gl_printf(fnt,SCREEN_W-text_length(fnt,title)>>1,(SCREEN_H>>2)+3+0.0f*text_height(fnt),0.0f,0xFFFFFF,title);		// Titre

	allegro_gl_printf(fnt,(SCREEN_W>>2)+5,(SCREEN_H>>2)+3+2*text_height(fnt),0.0f,0xFFFFFF,msg);		// Message
	allegro_gl_flip();
	}

	char *buf=NULL;

	if(ask) {
		buf=(char*) malloc(100);
		buf[0]=0;
		clear_keybuf();
		}

	bool done=false;

	do {
		if(key[KEY_ESC] || key[KEY_ENTER]) {
			while(key[KEY_ESC] || key[KEY_ENTER])
				rest(1);
			done=true;
			}
		else
			rest(1);

	if(ask) {
		glDisable(GL_TEXTURE_2D);
		glDisable(GL_BLEND);
		glColor4f(0.15f,0.15f,0.15f,1.0);
		glBegin(GL_QUADS);
			glVertex2i((SCREEN_W>>1)-100,SCREEN_H-text_height(fnt)>>1);
			glVertex2i((SCREEN_W>>1)+100,SCREEN_H-text_height(fnt)>>1);
			glVertex2i((SCREEN_W>>1)+100,SCREEN_H+text_height(fnt)>>1);
			glVertex2i((SCREEN_W>>1)-100,SCREEN_H+text_height(fnt)>>1);
		glEnd();
		glBegin(GL_LINES);
			glColor4f(0.0f,0.0f,0.0f,1.0);
			glVertex2i((SCREEN_W>>1)-100,SCREEN_H-text_height(fnt)>>1);			glVertex2i((SCREEN_W>>1)+100,SCREEN_H-text_height(fnt)>>1);
			glVertex2i((SCREEN_W>>1)-100,SCREEN_H-text_height(fnt)>>1);			glVertex2i((SCREEN_W>>1)-100,SCREEN_H+text_height(fnt)>>1);

			glColor4f(1.0f,1.0f,1.0f,1.0);
			glVertex2i((SCREEN_W>>1)+100,SCREEN_H+text_height(fnt)>>1);			glVertex2i((SCREEN_W>>1)-100,SCREEN_H+text_height(fnt)>>1);
			glVertex2i((SCREEN_W>>1)+100,SCREEN_H+text_height(fnt)>>1);			glVertex2i((SCREEN_W>>1)+100,SCREEN_H-text_height(fnt)>>1);
		glEnd();
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);

		if(keypressed()) {
			char key_code=readkey();
			switch(key_code)
			{
			case 27:
			case 9:
			case 10:
			case 13:
				break;
			case 8:
				if(buf[0])
					buf[strlen(buf)-1]=0;
				break;
			default:
				if(strlen(buf)<99 && text_length(fnt,buf)<180) {
					buf[strlen(buf)+1]=0;
					buf[strlen(buf)]=key_code;
					}
			};
			}

		allegro_gl_printf(fnt,(SCREEN_W>>1)-100,SCREEN_H-text_height(fnt)>>1,0.0f,0xFFFFFF,"%s_",buf);
		}

		allegro_gl_flip();
	}while(!done);

	allegro_gl_unset_allegro_mode();

	return buf;
}

//-------------- These are the GUI functions needed by the editors ----------------------------

FONT *gui_font=font;

			// Dessine un rectangle en pointillés
void rectdot(BITMAP *bmp,int x1,int y1,int x2,int y2,int col)
{
	if(bmp==screen) {
		glBegin(GL_POINTS);
			glColor3f(getr(col)/255.0f,getg(col)/255.0f,getb(col)/255.0f);
		for(int x=x1;x<=x2;x+=2) {
			glVertex2i(x,y1);
			glVertex2i(x,y2);
			}
		for(int y=y1;y<=y2;y+=2) {
			glVertex2i(x1,y);
			glVertex2i(x2,y);
			}
		glEnd();
		}
	else {
		for(int x=x1;x<=x2;x+=2) {
			putpixel(bmp,x,y1,col);
			putpixel(bmp,x,y2,col);
			}
		for(int y=y1;y<=y2;y+=2) {
			putpixel(bmp,x1,y,col);
			putpixel(bmp,x2,y,col);
			}
		}
}

	void GUIOBJ::create_button(int X1,int Y1,int X2,int Y2,char *Caption,void (*F)(int))
	{
		Type=OBJ_BUTTON;
		x1=X1;		y1=Y1;
		x2=X2;		y2=Y2;
		Etat=false;	Focus=false;
		Text=(char**) malloc(sizeof(char*));
		Text[0]=Caption;
		NString=1;
		Func=F;
	}
				// Crée une case à cocher
	void GUIOBJ::create_optionc(int X1,int Y1,char *Caption,bool ETAT,void (*F)(int))
	{
		Type=OBJ_OPTIONC;
		x1=X1;							y1=Y1;
		x2=X1+8*strlen(Caption)+12;		y2=Y1+12;
		Etat=ETAT;	
		Focus=false;
		Text=(char**) malloc(sizeof(char*));
		Text[0]=Caption;
		NString=1;
		Func=F;
	}
				// Crée un bouton d'option
	void GUIOBJ::create_optionb(int X1,int Y1,char *Caption,bool ETAT,void (*F)(int))
	{
		Type=OBJ_OPTIONB;
		x1=X1;							y1=Y1;
		x2=X1+8*strlen(Caption)+12;		y2=Y1+12;
		Etat=ETAT;	
		Focus=false;
		Text=(char**) malloc(sizeof(char*));
		Text[0]=Caption;
		NString=1;
		Func=F;
	}
				// Crée une barre d'entrée de texte
	void GUIOBJ::create_textbar(int X1,int Y1,int X2,int Y2,char *Caption,int MaxChar, void(*F)(int))
	{
		Type=OBJ_TEXTBAR;
		x1=X1;							y1=Y1;
		x2=X2;							y2=Y2;
		Etat=false;	
		Focus=false;
		Text=(char**) malloc(sizeof(char*));
		Text[0]=Caption;
		NString=1;
		Func=F;
		Data=MaxChar;
	}
				// Crée un menu flottant
	void GUIOBJ::create_menu(int X1,int Y1,char *Entry[],int NbEntry,void (*F)(int))
	{
		Type=OBJ_FMENU;
		x1=X1;							y1=Y1;
		x2=X1+168;						y2=Y1+8*NbEntry+8;
		Etat=false;	
		Focus=false;
		Text=(char**) malloc(sizeof(char*)*NbEntry);
		for(int i=0;i<NbEntry;i++)
		   Text[i]=Entry[i];
		NString=NbEntry;
		Func=F;
	}
				// Crée un menu déroulant
	void GUIOBJ::create_menu(int X1,int Y1,int X2,int Y2,char *Entry[],int NbEntry,void (*F)(int))
	{
		Type=OBJ_MENU;
		x1=X1;							y1=Y1;
		x2=X2;							y2=Y2;
		Etat=false;	
		Focus=false;
		Text=(char**) malloc(sizeof(char*)*NbEntry);
		for(int i=0;i<NbEntry;i++)
		   Text[i]=Entry[i];
		NString=NbEntry;
		Pos=0;				// Position sur la liste
		Func=F;
	}
				// Crée une barre de progression
	void GUIOBJ::create_pbar(int X1,int Y1,int X2,int Y2,int PCent)
	{
		Type=OBJ_PBAR;
		x1=X1;							y1=Y1;
		x2=X2;							y2=Y2;
		Etat=false;	
		Focus=false;
		Text=NULL;
		NString=0;
		Func=NULL;
		Data=PCent;
	}
				// Crée un objet text
	void GUIOBJ::create_text(int X1,int Y1,char *Caption,int Col)
	{
		Type=OBJ_TEXT;
		x1=X1;							y1=Y1;
		x2=X1+strlen(Caption)*8;		y2=Y1+8;
		Etat=false;	
		Focus=false;
		Text=(char**) malloc(sizeof(char*));;
		Text[0]=Caption;
		NString=1;
		Func=NULL;
		Data=Col;
	}

	/*---------------------------------------------------------------------------\
	|               Dessine la fenêtre ainsi que tous ses objets                 |
	\---------------------------------------------------------------------------*/

void WND::draw(BITMAP *bmp,bool Focus,bool Deg)
{
			// Fenêtre
	rectfillgl(bmp,x,y,x+width-1,y+height-1,GrisM);
	rectgl(bmp,x,y,x+width-1,y+height-1,Noir);
	rectgl(bmp,x+1,y+1,x+width-2,y+height-2,GrisF);
	linegl(bmp,x,y,x+width-1,y,Blanc);
	linegl(bmp,x,y,x,y+height-1,Blanc);
	linegl(bmp,x+1,y+1,x+width-2,y+1,GrisC);
	linegl(bmp,x+1,y+1,x+1,y+height-2,GrisC);
	if(Deg) {
		if(Focus)	{
			glBegin(GL_QUADS);
				glColor3f(0.0f,0.0f,1.0f);		glVertex2f(x+3,y+3);
				glColor3f(0.5f,0.5f,0.75f);		glVertex2f(x+width-4,y+3);
				glColor3f(0.5f,0.5f,0.75f);		glVertex2f(x+width-4,y+11);
				glColor3f(0.0f,0.0f,1.0f);		glVertex2f(x+3,y+11);
			glEnd();
			}
		else	{
			glBegin(GL_QUADS);
				glColor3f(0.75f,0.75f,0.75f);		glVertex2f(x+3,y+3);
				glColor3f(0.5f,0.5f,0.5f);			glVertex2f(x+width-4,y+3);
				glColor3f(0.5f,0.5f,0.5f);			glVertex2f(x+width-4,y+11);
				glColor3f(0.75f,0.75f,0.75f);		glVertex2f(x+3,y+11);
			glEnd();
			}
		}
	else {
		if(Focus)
			rectfillgl(bmp,x+3,y+3,x+width-4,y+11,Bleu);
		else
			rectfillgl(bmp,x+3,y+3,x+width-4,y+11,GrisF);
		}
	agl_textout(bmp,gui_font,Title,x+4,y+4,Blanc);
			// Objets
	if(NbObj>0 && Objets!=NULL) {
		for(int i=0;i<NbObj;i++)			// Affiche les objets d'arrière plan
			switch(Objets[i].Type)
			{
			case OBJ_BUTTON:		// Boutton
				button(x+Objets[i].x1,y+Objets[i].y1,x+Objets[i].x2,y+Objets[i].y2,Objets[i].Text[0],Objets[i].Etat,bmp);
				if(Objets[i].Focus && Focus)
					rectdot(bmp,Objets[i].x1+x-2,Objets[i].y1+y-2,Objets[i].x2+x+2,Objets[i].y2+y+2,GrisF);
				break;
			case OBJ_OPTIONC:		// Case à cocher
				OptionCase(x+Objets[i].x1,y+Objets[i].y1,Objets[i].Text[0],Objets[i].Etat,bmp);
				if(Objets[i].Focus && Focus)
					rectdot(bmp,Objets[i].x1+x-2,Objets[i].y1+y-2,Objets[i].x2+x+2,Objets[i].y2+y+2,GrisF);
				break;
			case OBJ_OPTIONB:		// Boutton d'option	
				OptionButton(x+Objets[i].x1,y+Objets[i].y1,Objets[i].Text[0],Objets[i].Etat,bmp);
				if(Objets[i].Focus && Focus)
					rectdot(bmp,Objets[i].x1+x-2,Objets[i].y1+y-2,Objets[i].x2+x+2,Objets[i].y2+y+2,GrisF);
				break;
			case OBJ_PBAR:			// Barre de progression
				ProgressBar(x+Objets[i].x1,y+Objets[i].y1,x+Objets[i].x2,y+Objets[i].y2,Objets[i].Data,bmp);
				if(Objets[i].Focus && Focus)
					rectdot(bmp,Objets[i].x1+x-2,Objets[i].y1+y-2,Objets[i].x2+x+2,Objets[i].y2+y+2,GrisF);
				break;
			case OBJ_TEXTBAR:		// Barre de saisie de texte
				TextBar(x+Objets[i].x1,y+Objets[i].y1,x+Objets[i].x2,y+Objets[i].y2,Objets[i].Text[0],Objets[i].Focus,bmp);
				if(Objets[i].Focus && Focus)
					rectdot(bmp,Objets[i].x1+x-2,Objets[i].y1+y-2,Objets[i].x2+x+2,Objets[i].y2+y+2,GrisF);
				break;
			case OBJ_TEXT:
				agl_textout(bmp,gui_font,Objets[i].Text[0],x+Objets[i].x1,Objets[i].y1+y,Objets[i].Data);
				break;
			};
		for(int i=0;i<NbObj;i++)			// Affiche les objets de premier plan
			switch(Objets[i].Type)
			{
			case OBJ_FMENU:			// Menu flottant
				FloatMenu(x+Objets[i].x1,y+Objets[i].y1,Objets[i].Text,Objets[i].NString,bmp,Objets[i].Data);
				break;
			case OBJ_MENU:			// Menu déroulant
				button(x+Objets[i].x1,y+Objets[i].y1,x+Objets[i].x2,y+Objets[i].y2,Objets[i].Text[0],Objets[i].Etat,bmp);
				if(Objets[i].Etat)
					FloatMenu(x+Objets[i].x1,y+Objets[i].y2+1,&(Objets[i].Text[1+Objets[i].Pos]),Objets[i].NString-1-Objets[i].Pos,bmp,Objets[i].Data-Objets[i].Pos);
				break;
			};
		}
}			// Fin de draw(BITMAP *bmp)

	/*---------------------------------------------------------------------------\
	|        Déplace la fenêtre et détecte si la souris s'y trouve               |
	\---------------------------------------------------------------------------*/

unsigned char WND::WinMov(int AMx,int AMy,int AMb,int Mx,int My,int Mb)
{
	byte WinMouse=0;
	if(AMb==1&&Mb==1 && !Lock)
		if(AMx>=x+3&&AMx<=x+width-4)
			if(AMy>=y+3&&AMy<=y+11) {
				x+=Mx-AMx;
				y+=My-AMy;
				}
	if(Mx>=x&&Mx<=x+width&&My>=y&&My<=y+height)
		WinMouse=1;
	return WinMouse;
}				// Fin de WinMov

	/*---------------------------------------------------------------------------\
	|             Gère les interactions entre l'utilisateur et les objets        |
	\---------------------------------------------------------------------------*/
int WND::check(int AMx,int AMy,int AMb,bool timetoscroll)
{
	int IsOnGUI;
		// Vérifie si la souris est sur la fenêtre et/ou si elle la déplace
	IsOnGUI=WinMov(AMx,AMy,AMb,mouse_x,mouse_y,mouse_b);
			// S'il n'y a pas d'objets, on arrête
	if(NbObj<=0 || Objets==NULL)	return IsOnGUI;

			// Interactions utilisateur/objets
	bool MouseOn;		// Si la souris est sur l'objet
	int index,e;
	byte Key;
	bool was_on_floating_menu = false;
	for(int i=0;i<NbObj;i++) {
		MouseOn=false;
					// Vérifie si la souris est sur l'objet
		if(mouse_x>=x+Objets[i].x1 && mouse_x<=x+Objets[i].x2
			&& mouse_y>=y+Objets[i].y1 && mouse_y<=y+Objets[i].y2)	MouseOn=true;

		if(Objets[i].Type==OBJ_MENU && Objets[i].Etat && !MouseOn)
			if(mouse_x>=x+Objets[i].x1 && mouse_x<=x+Objets[i].x1+168
				&& mouse_y>y+Objets[i].y2 && mouse_y<=y+Objets[i].y2+1+8*Objets[i].NString)
				MouseOn=true;

		if(MouseOn) IsOnGUI|=2;

		if(mouse_b!=0 && MouseOn) {		// Obtient le focus
			for(e=0;e<NbObj;e++)
				Objets[e].Focus=false;
			Objets[i].Focus=true;
			}

		if(mouse_b!=0 && !MouseOn)	{	// Perd le focus
			Objets[i].Focus=false;
			switch(Objets[i].Type)
			{
			case OBJ_MENU:
				Objets[i].Etat=false;
				break;
			};
			}

		if(MouseOn && (Objets[i].Type==OBJ_FMENU || Objets[i].Type==OBJ_MENU)) {
			for(e=0;e<NbObj;e++) {
				Objets[e].Focus=false;
				if(Objets[e].Type==OBJ_BUTTON)
					Objets[e].Etat=false;
				}
			was_on_floating_menu = true;
			Objets[i].Focus=true;
			}

		switch(Objets[i].Type)
		{
		case OBJ_MENU:			// Choses à faire quoi qu'il arrive
			Objets[i].Data=-1;		// Pas de séléction
			if(MouseOn && mouse_x>=x+Objets[i].x1 && mouse_x<=x+Objets[i].x1+168
				&& mouse_y>y+Objets[i].y2+4 && mouse_y<=y+Objets[i].y2+1+8*Objets[i].NString
				&& Objets[i].Etat){

				if(timetoscroll) {
					if(mouse_y<y+Objets[i].y2+12 && Objets[i].Pos>0)
						Objets[i].Pos--;
					if(mouse_y>SCREEN_H-8 && y+Objets[i].y2+1+8*(Objets[i].NString-Objets[i].Pos)>SCREEN_H)
						Objets[i].Pos++;
					}
				Objets[i].Data=(mouse_y-y-Objets[i].y2-5)/8+Objets[i].Pos;
				if(Objets[i].Data>=Objets[i].NString-1) Objets[i].Data=-1;
				}
			break;
		case OBJ_FMENU:
			Objets[i].Data=-1;		// Pas de séléction
				if(MouseOn && mouse_y>=y+Objets[i].y1+4 && mouse_y<=y+Objets[i].y2-4) {
					Objets[i].Data=(mouse_y-y-Objets[i].y1-4)/8;
					if(Objets[i].Data>=Objets[i].NString) Objets[i].Data=-1;
					}
			break;
		case OBJ_TEXTBAR:				// Permet l'entrée de texte
			Objets[i].Etat=false;
			if(Objets[i].Focus && keypressed()) {
				Key=readkey()&0xff;
				switch(Key)
				{
				case 8:
					if(strlen(Objets[i].Text[0])>0)
						Objets[i].Text[0][strlen(Objets[i].Text[0])-1]=0;
					break;
				case 13:
					Objets[i].Etat=true;
					if(Objets[i].Func!=NULL)
						(*Objets[i].Func)(strlen(Objets[i].Text[0]));
					break;
				case 0:
					break;
				default:
				    if(strlen(Objets[i].Text[0])+1<Objets[i].Data) {	
						Objets[i].Text[0][strlen(Objets[i].Text[0])+1]=0;
						Objets[i].Text[0][strlen(Objets[i].Text[0])]=Key;
						}
				};
				}
			break;
			};

		if((mouse_b!=1 || !MouseOn) && Objets[i].Type==OBJ_BUTTON && Objets[i].Etat && !was_on_floating_menu) { 
			if(Objets[i].Func!=NULL)
				(*Objets[i].Func)(0);		// Lance la fonction associée
			Objets[i].Etat=false;
			}

		if(mouse_b==1 && AMb!=1 && MouseOn)		// Click sur l'objet
			switch(Objets[i].Type)
			{
			case OBJ_BUTTON:		// Boutton
				if(was_on_floating_menu)	break;
				Objets[i].Etat=true;
				break;
			case OBJ_OPTIONC:		// Case à cocher
			case OBJ_OPTIONB:		// Boutton d'option
				if(was_on_floating_menu)	break;
				if(mouse_x<=x+Objets[i].x1+12 && mouse_y<=y+Objets[i].y1+12)
					Objets[i].Etat^=true;
				if(Objets[i].Func!=NULL)
					(*Objets[i].Func)(Objets[i].Etat);	// Lance la fonction associée
				break;
			case OBJ_FMENU:			// Menu Flottant
				if(mouse_y>=y+Objets[i].y1+4 && mouse_y<=y+Objets[i].y2-4) {
					index=(mouse_y-y-Objets[i].y1-4)/8;
					if(index>=Objets[i].NString) index=Objets[i].NString-1;
					if(Objets[i].Func!=NULL)
						(*Objets[i].Func)(index);		// Lance la fonction associée
					}
				break;
			case OBJ_MENU:			// Menu déroulant
				if(mouse_x>=x+Objets[i].x1 && mouse_x<=x+Objets[i].x1+168
					&& mouse_y>y+Objets[i].y2 && mouse_y<=y+Objets[i].y2+1+8*Objets[i].NString
					&& Objets[i].Etat){

					index=(mouse_y-y-Objets[i].y2-5)/8+Objets[i].Pos;
					if(index>=Objets[i].NString-1) index=Objets[i].NString-2;
					if(Objets[i].Func!=NULL)
						(*Objets[i].Func)(index);		// Lance la fonction associée
					Objets[i].Etat=false;
					}
				else
					Objets[i].Etat^=true;
				break;
			};
		}
	return IsOnGUI;
}			// Fin de check

/*---------------------------------------------------------------------------\
|        Dessine une fenêtre avec les paramètres Wnd de type window          |
\---------------------------------------------------------------------------*/

void draw_Window(wnd Wnd,BITMAP *bmp)
{
rectfillgl(bmp,Wnd.x,Wnd.y,Wnd.x+Wnd.width-1,Wnd.y+Wnd.height-1,GrisM);
rectgl(bmp,Wnd.x,Wnd.y,Wnd.x+Wnd.width-1,Wnd.y+Wnd.height-1,Noir);
rectgl(bmp,Wnd.x+1,Wnd.y+1,Wnd.x+Wnd.width-2,Wnd.y+Wnd.height-2,GrisF);
linegl(bmp,Wnd.x,Wnd.y,Wnd.x+Wnd.width-1,Wnd.y,Blanc);
linegl(bmp,Wnd.x,Wnd.y,Wnd.x,Wnd.y+Wnd.height-1,Blanc);
linegl(bmp,Wnd.x+1,Wnd.y+1,Wnd.x+Wnd.width-2,Wnd.y+1,GrisC);
linegl(bmp,Wnd.x+1,Wnd.y+1,Wnd.x+1,Wnd.y+Wnd.height-2,GrisC);
rectfillgl(bmp,Wnd.x+3,Wnd.y+3,Wnd.x+Wnd.width-4,Wnd.y+11,Bleu);
agl_textout(bmp,gui_font,Wnd.Title,Wnd.x+4,Wnd.y+4,Blanc);
}

/*---------------------------------------------------------------------------\
|        Déplace une fenêtre avec les paramètres Wnd de type window          |
\---------------------------------------------------------------------------*/

unsigned char WinMov(int AMx,int AMy,int AMb,int Mx,int My,int Mb,wnd *Wnd)
{
byte WinMouse=0;
if(AMb==1&&Mb==1)
   if(AMx>=(*Wnd).x+3&&AMx<=(*Wnd).x+(*Wnd).width-4)
      if(AMy>=(*Wnd).y+3&&AMy<=(*Wnd).y+11) {
         (*Wnd).x+=Mx-AMx;
         (*Wnd).y+=My-AMy;
      }
if(Mx>=(*Wnd).x&&Mx<=(*Wnd).x+(*Wnd).width&&My>=(*Wnd).y&&My<=(*Wnd).y+(*Wnd).height)
   WinMouse=1;
return WinMouse;
}

/*---------------------------------------------------------------------------\
|        Dessine un bouton en (x,y) avec le texte Title,enfoncé si Etat=1    |
\---------------------------------------------------------------------------*/

void button (int x,int y,int x2,int y2,char *Title,bool Etat,BITMAP *bmp)
{
rectfillgl(bmp,x,y,x2,y2,GrisM);
rectgl(bmp,x,y,x2,y2,Noir);
rectgl(bmp,x+1,y+1,x2-1,y2-1,GrisF);
if(!Etat) {
   linegl(bmp,x,y,x2,y,Blanc);
   linegl(bmp,x,y,x,y2,Blanc);
   linegl(bmp,x+1,y+1,x2-1,y+1,GrisC);
   linegl(bmp,x+1,y+1,x+1,y2-1,GrisC);
   agl_textout(bmp,gui_font,Title,(x+x2>>1)-(strlen(Title)<<2),(y+y2-8>>1),Noir);
   }
else {
   linegl(bmp,x2,y2,x2,y,Blanc);
   linegl(bmp,x2,y2,x,y2,Blanc);
   linegl(bmp,x2-1,y2-1,x2-1,y+1,GrisC);
   linegl(bmp,x2-1,y2-1,x+1,y2-1,GrisC);
   agl_textout(bmp,gui_font,Title,(x+x2>>1)-(strlen(Title)<<2)+1,(y+y2-8>>1)+1,Noir);
   }
}

/*---------------------------------------------------------------------------\
|        Dessine un menu flotant avec les paramètres de Entry[]              |
\---------------------------------------------------------------------------*/

void FloatMenu(int x,int y,char *Entry[],int NumEntry,BITMAP *bmp,int Index)
{
rectfillgl(bmp,x,y,x+168,y+8+8*NumEntry,GrisM);
rectgl(bmp,x,y,x+168,y+8+8*NumEntry,Noir);
rectgl(bmp,x+1,y+1,x+167,y+7+8*NumEntry,GrisF);
linegl(bmp,x,y,x,y+8+8*NumEntry,Blanc);
linegl(bmp,x,y,x+168,y,Blanc);
linegl(bmp,x+1,y+1,x+1,y+7+8*NumEntry,GrisC);
linegl(bmp,x+1,y+1,x+167,y+1,GrisC);

int i;
for(i=0;i<NumEntry;i++) {
	if(i==Index)
		rectfillgl(bmp,x+4,y+4+8*i,x+164,y+12+8*i,Bleu);
	agl_textout(bmp,gui_font,Entry[i],x+4,y+4+8*i,Noir);
	}

}

/*---------------------------------------------------------------------------\
|        Dessine un boutton d'option avec le texte Title                     |
\---------------------------------------------------------------------------*/

void OptionButton(int x,int y,char *Title,bool Etat,BITMAP *bmp)
{
int x1,y1;

circlefill(bmp,x+6,y+6,6,Blanc);
circle(bmp,x+6,y+6,6,GrisM);
circle(bmp,x+6,y+6,5,GrisF);

                // Effet d'ombrage
for(y1=y;y1<=y+12;y1++)
   for(x1=x;x1<=x+12;x1++)
      if((x1-x-6)*(x1-x-6)+(y1-y-6)*(y1-y-6)<49)
         if(getpixel(bmp,x1,y1)==GrisF&&x1-x+y1-y-6>6)
            putpixel(bmp,x1,y1,GrisC);

if(Etat) {
   putpixel(bmp,x+6,y+6,RougeF);
   circle(bmp,x+6,y+6,1,RougeF);
   circle(bmp,x+6,y+6,2,RougeF);
   circle(bmp,x+6,y+6,3,RougeF);
   circlefill(bmp,x+6,y+6,2,RougeF);
   putpixel(bmp,x+6,y+6,Rouge);
   circle(bmp,x+6,y+6,1,Rouge);
   circle(bmp,x+6,y+6,2,Rouge);
   circlefill(bmp,x+6,y+6,2,Rouge);
   }

agl_textout(bmp,gui_font,Title,x+16,y+3,Noir);
}

/*---------------------------------------------------------------------------\
|        Dessine une case à cocher avec le texte Title                       |
\---------------------------------------------------------------------------*/

void OptionCase(int x,int y,char *Title,bool Etat,BITMAP *bmp)
{

rectfillgl(bmp,x,y,x+12,y+12,Blanc);
rectgl(bmp,x,y,x+12,y+12,GrisF);
rectgl(bmp,x+1,y+1,x+11,y+11,Noir);
linegl(bmp,x,y+12,x+12,y+12,GrisC);
linegl(bmp,x+12,y,x+12,y+12,GrisC);
linegl(bmp,x+1,y+11,x+11,y+11,Blanc);
linegl(bmp,x+11,y+1,x+11,y+11,Blanc);

if(Etat) {
   linegl(bmp,x+3,y+6,x+5,y+9,GrisF);
   linegl(bmp,x+5,y+9,x+8,y+4,GrisF);
   linegl(bmp,x+3,y+5,x+5,y+8,GrisF);
   linegl(bmp,x+5,y+8,x+8,y+3,GrisF);
   }

agl_textout(bmp,gui_font,Title,x+16,y+3,Noir);
}

/*---------------------------------------------------------------------------\
|        Dessine une barre d'entrée de texte utilisateur                     |
\---------------------------------------------------------------------------*/

void TextBar(int x1,int y1,int x2,int y2,char *Caption,bool Etat,BITMAP *bmp)
{
rectfillgl(bmp,x1,y1,x2,y2,Blanc);
rectgl(bmp,x1,y1,x2,y2,GrisF);
rectgl(bmp,x1+1,y1+1,x2-1,y2-1,Noir);
linegl(bmp,x1,y2,x2,y2,GrisC);
linegl(bmp,x2,y1,x2,y2,GrisC);
linegl(bmp,x1+1,y2-1,x2-1,y2-1,Blanc);
linegl(bmp,x2-1,y1+1,x2-1,y2-1,Blanc);

agl_textout(bmp,gui_font,Caption,x1+4,y1+4,Noir);
if(Etat) agl_textout(bmp,gui_font,"_",x1+4+8*strlen(Caption),y1+4,Noir);

}

/*---------------------------------------------------------------------------\
|                     Dessine une barre de progression                       |
\---------------------------------------------------------------------------*/

void ProgressBar(int x1,int y1,int x2,int y2,int Value,BITMAP *bmp)
{
rectfillgl(bmp,x1,y1,x2,y2,Blanc);
rectfillgl(bmp,x1+2,y1,x1+1+(x2-x1-3)*Value/100,y2,Bleu);
rectgl(bmp,x1,y1,x2,y2,GrisF);
rectgl(bmp,x1+1,y1+1,x2-1,y2-1,Noir);
linegl(bmp,x1,y2,x2,y2,GrisC);
linegl(bmp,x2,y1,x2,y2,GrisC);
linegl(bmp,x1+1,y2-1,x2-1,y2-1,Blanc);
linegl(bmp,x2-1,y1+1,x2-1,y2-1,Blanc);

char *Buf="     ";

uszprintf(Buf,5,"%d",Value);

#ifdef TA3D_PLATFORM_WINDOWS
strcat(Buf,"%");
#else
Buf=strcat(Buf,"%");
#endif

agl_textout(bmp,gui_font,Buf,(x1+x2)/2-strlen(Buf)*4,(y1+y2)/2-4,Noir);

}

			// Renvoie le dossier contenant le fichier fname
String dirname(String fname)
{
	int last=0;
	for(int i=0;i<fname.length();i++) {
		if(fname[i]=='\\')
			fname[i]='/';
		if(fname[i]=='/')
			last=i;
		}
	fname.resize(last);
	if(fname.length()==0)	fname="/";

	return fname;
}

/*---------------------------------------------------------------------------\
|               Affiche une fenêtre de selection de fichier                  |
\---------------------------------------------------------------------------*/

char * Dialog(char *Title,char *Filter)
{

wnd WAsk;               //Cree un objet fenetre

String Name = "";
byte key=0;
int AMouseX,AMouseY,AMouseB,AMouseZ;

   WAsk.Title=Title;       //Defini les proprietes de la fenetre
   WAsk.width=500;
   WAsk.height=400;
   WAsk.x=(*screen).w-WAsk.width>>1;
   WAsk.y=(*screen).h-WAsk.height>>1;

BITMAP *Img=create_bitmap(SCREEN_W,SCREEN_H);
blit(screen,Img,0,0,0,0,SCREEN_W,SCREEN_H);

//-----  Pour la gestion de l'aborescence des dossiers  ----------------------

int DecF=0,DecD=0;

String CurDir = getcwd(NULL,1000);
     // Pour l'arborescence des fichiers
al_ffblk f;
list<String> Files;
list<String> Dir;
int NbFiles=0,NbDir=0;
int i,done,e;

                // Détecte les fichiers/dossiers

detect:

Files.clear();
Dir.clear();

done=al_findfirst((CurDir+"/*.*").c_str(),&f,FA_LABEL|FA_HIDDEN|FA_SYSTEM|FA_DIREC);
if(done==0) {
   NbDir=0;
   while(done==0) {
      if((f.attrib&FA_DIREC)==FA_DIREC) {
    	 NbDir++;
    	 Dir.push_back(f.name);
         }
      done=al_findnext(&f);
      }
   }
else { NbDir=0; }

done=al_findfirst((CurDir+"/"+Filter).c_str(),&f,FA_LABEL|FA_HIDDEN|FA_SYSTEM|FA_ARCH);
if(done==0) {
   NbFiles=0;
   while(done==0) {
	  NbFiles++;
	  Files.push_back(f.name);
      done=al_findnext(&f);
      }
   }
else { NbFiles=0; }

                // Tri des fichiers par ordre alphabétique
Files.sort();

                // Tri des dossiers par ordre alphabétique
Dir.sort();

done=0;

//----------------------------------------------------------------------------

DecD=DecF=0;

do
{

glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Efface l'écran
		
allegro_gl_set_allegro_mode();	// On repasse dans le mode dessin 2D pour Allegro

blit(Img,screen,0,0,0,0,SCREEN_W,SCREEN_H);

//-------  Gestion de la souris  ---------------------------------------------

AMouseX=mouse_x;
AMouseY=mouse_y;
AMouseZ=mouse_z;
AMouseB=mouse_b;
poll_mouse();

//-------  Fin du code de gestion de la souris  ------------------------------

key=0;
if(keypressed())
   key=readkey();

if(key==8 && Name.length()>0) Name.resize(Name.length()-1);
if(key==8) key=0;
if(key!=0 && key!=27 && key!=13 && Name.length()*8<WAsk.width-154) Name+=key;
if(key==27||key==13) done=1;
if(Name.length()>(WAsk.width-24>>3)) Name.resize(Name.length()-1);

   draw_Window(WAsk,screen);        // Affiche la fenêtre

                // Objets de la fenêtre
                // Barre nom du fichier
   agl_textout(screen,gui_font,"Nom du fichier:",WAsk.x+5,WAsk.y+19,0x00);
   TextBar(WAsk.x+125,WAsk.y+16,WAsk.x+WAsk.width-5,WAsk.y+30,(char*)Name.c_str(),(retrace_count%60)>30,screen);

                // Liste des dossiers
   agl_textout(screen,gui_font,"Liste des dossiers:",WAsk.x+21,WAsk.y+40,0x00);
   TextBar(WAsk.x+5,WAsk.y+50,WAsk.x+190,WAsk.y+WAsk.height-10,"",false,screen);
                // Affiche le nom des dossiers
   if(NbDir>0) {
   		int f=0;
      for(list<String>::iterator e=Dir.begin();e!=Dir.end();e++) {
         i=f-DecD;
         f++;
         if(i>=41) break;
         if(i>=0) {
            agl_textout(screen,gui_font,(char*)e->c_str(),WAsk.x+20,WAsk.y+56+8*i,0x00);
            linegl(screen,WAsk.x+10,WAsk.y+53+8*i,WAsk.x+10,WAsk.y+60+i*8,0x00);
            linegl(screen,WAsk.x+10,WAsk.y+60+8*i,WAsk.x+17,WAsk.y+60+i*8,0x00);
            }
         }
        }
   if(NbDir>0&&mouse_b==1&&mouse_x>=WAsk.x+7&&mouse_x<=WAsk.x+188
    &&mouse_y>=WAsk.y+56&&mouse_y<=WAsk.y+WAsk.height-10) {
      i=(mouse_y-WAsk.y-56)/8;
      e=i+DecD;
      list<String>::iterator curdir=Dir.begin();
      for(int f=0;f<e;f++)	curdir++;
      if(i<41&&e>=0&&e<NbDir) {
         if(strcmp(curdir->c_str(),".")!=0 && strcmp(curdir->c_str(),"..")!=0)
            CurDir+=string("/")+*curdir;
         else
            CurDir=dirname(CurDir);
         while(mouse_b!=0)
            poll_mouse();
		 allegro_gl_unset_allegro_mode();
         goto detect;
         }
      }
         
                // Liste des fichiers
   agl_textout(screen,gui_font,"Liste des fichiers:",WAsk.x+226,WAsk.y+40,0x00);
   TextBar(WAsk.x+210,WAsk.y+50,WAsk.x+480,WAsk.y+WAsk.height-10,"",false,screen);
                // Affiche le nom des fichiers
   if(NbFiles>0) {
   	  int f=0;
      for(list<String>::iterator e=Files.begin();e!=Files.end();e++) {
         i=f-DecF;
         f++;
         if(i>=41) break;
         if(i>=0) {
            agl_textout(screen,gui_font,(char*)e->c_str(),WAsk.x+225,WAsk.y+56+8*i,0x00);
            linegl(screen,WAsk.x+215,WAsk.y+53+8*i,WAsk.x+215,WAsk.y+60+i*8,0x00);
            linegl(screen,WAsk.x+215,WAsk.y+60+8*i,WAsk.x+222,WAsk.y+60+i*8,0x00);
            }
         }
      }
   if(NbFiles>0&&mouse_x>=WAsk.x+212&&mouse_x<=WAsk.x+478
    &&mouse_y>=WAsk.y+56&&mouse_y<=WAsk.y+WAsk.height-10) {
      i=(mouse_y-WAsk.y-56)/8;
      e=i+DecF;
      list<String>::iterator curfile=Files.begin();
      for(int f=0;f<e;f++)	curfile++;
      if(mouse_b==1&&i<41&&e>=0&&e<NbFiles)
		 Name=*curfile;
      }

                // Barres de défilement
	if(mouse_x>=WAsk.x+210 && mouse_x<=WAsk.x+480 && mouse_y>=WAsk.y+50 && mouse_y<=WAsk.y+WAsk.height-10) {
		DecF+=AMouseZ-mouse_z;
		if(DecF>NbFiles-40)	DecF=NbFiles-40;
		if(DecF<0)	DecF=0;
		}
	if(mouse_x>=WAsk.x+5 && mouse_x<=WAsk.x+190 && mouse_y>=WAsk.y+50 && mouse_y<=WAsk.y+WAsk.height-10) {
		DecD+=AMouseZ-mouse_z;
		if(DecD>NbDir-40)	DecD=NbDir-40;
		if(DecD<0)	DecD=0;
		}
                // Fichiers
   rectfillgl(screen,WAsk.x+481,WAsk.y+50,WAsk.x+493,WAsk.y+WAsk.height-10,0x9F9F9F);
                // Haut
   if(mouse_b==1&&mouse_x>=WAsk.x+481&&mouse_x<=WAsk.x+493
    &&mouse_y>=WAsk.y+50&&mouse_y<=WAsk.y+62) {
      DecF--;
      if(DecF<0) DecF=0;
      button(WAsk.x+481,WAsk.y+50,WAsk.x+493,WAsk.y+62,"",true,screen);
      }
   else
      button(WAsk.x+481,WAsk.y+50,WAsk.x+493,WAsk.y+62,"",false,screen);
   linegl(screen,WAsk.x+484,WAsk.y+58,WAsk.x+487,WAsk.y+55,0x00);
   linegl(screen,WAsk.x+484,WAsk.y+57,WAsk.x+487,WAsk.y+54,0x00);
   linegl(screen,WAsk.x+490,WAsk.y+58,WAsk.x+487,WAsk.y+55,0x00);
   linegl(screen,WAsk.x+490,WAsk.y+57,WAsk.x+487,WAsk.y+54,0x00);
                // Bas
   if(mouse_b==1&&mouse_x>=WAsk.x+481&&mouse_x<=WAsk.x+493
    &&mouse_y>=WAsk.y+WAsk.height-22&&mouse_y<=WAsk.y+WAsk.height-10) {
      DecF++;
      if(DecF>NbFiles-40) DecF=NbFiles-40;
      if(DecF<0) DecF=0;
      button(WAsk.x+481,WAsk.y+WAsk.height-22,WAsk.x+493,WAsk.y+WAsk.height-10,"",true,screen);
      }
   else
      button(WAsk.x+481,WAsk.y+WAsk.height-22,WAsk.x+493,WAsk.y+WAsk.height-10,"",false,screen);
   linegl(screen,WAsk.x+484,WAsk.y+WAsk.height-18,WAsk.x+487,WAsk.y+WAsk.height-15,0x00);
   linegl(screen,WAsk.x+484,WAsk.y+WAsk.height-17,WAsk.x+487,WAsk.y+WAsk.height-14,0x00);
   linegl(screen,WAsk.x+490,WAsk.y+WAsk.height-18,WAsk.x+487,WAsk.y+WAsk.height-15,0x00);
   linegl(screen,WAsk.x+490,WAsk.y+WAsk.height-17,WAsk.x+487,WAsk.y+WAsk.height-14,0x00);
                // Carré
   if(NbFiles!=0&&NbFiles>40)
      i=WAsk.y+63+DecF*(WAsk.height-97)/(NbFiles-39);
   else
      i=WAsk.y+63;
   e=i+12;
   button(WAsk.x+481,i,WAsk.x+493,e,"",0x00,screen);
   if(mouse_b==1&&AMouseB==1&&NbFiles>40
    &&mouse_y!=AMouseY
    &&AMouseX>=WAsk.x+481&&AMouseX<=WAsk.x+493
    &&mouse_x>=WAsk.x+481&&mouse_x<=WAsk.x+493
    &&mouse_y>=WAsk.y+63&&mouse_y<WAsk.y+WAsk.height-22) {
       i=mouse_y-6;
       DecF=(i-WAsk.y-63)*(NbFiles-40)/(WAsk.height-97);
       if(DecF>NbFiles-40) DecF=NbFiles-40;
       if(DecF<0) DecF=0;
       }
                // Dossiers
   rectfillgl(screen,WAsk.x+191,WAsk.y+50,WAsk.x+203,WAsk.y+WAsk.height-10,0x9F9F9F);
                // Haut
   if(mouse_b==1&&mouse_x>=WAsk.x+191&&mouse_x<=WAsk.x+203
    &&mouse_y>=WAsk.y+50&&mouse_y<=WAsk.y+62) {
      DecD--;
      if(DecD<0) DecD=0;
      button(WAsk.x+191,WAsk.y+50,WAsk.x+203,WAsk.y+62,"",true,screen);
      }
   else
      button(WAsk.x+191,WAsk.y+50,WAsk.x+203,WAsk.y+62,"",false,screen);
   linegl(screen,WAsk.x+194,WAsk.y+58,WAsk.x+197,WAsk.y+55,0x00);
   linegl(screen,WAsk.x+194,WAsk.y+57,WAsk.x+197,WAsk.y+54,0x00);
   linegl(screen,WAsk.x+200,WAsk.y+58,WAsk.x+197,WAsk.y+55,0x00);
   linegl(screen,WAsk.x+200,WAsk.y+57,WAsk.x+197,WAsk.y+54,0x00);
                // Bas
   if(mouse_b==1&&mouse_x>=WAsk.x+191&&mouse_x<=WAsk.x+203
    &&mouse_y>=WAsk.y+WAsk.height-22&&mouse_y<=WAsk.y+WAsk.height-10) {
      DecD++;
      if(DecD>NbDir-40) DecD=NbDir-40;
      if(DecD<0) DecD=0;
      button(WAsk.x+191,WAsk.y+WAsk.height-22,WAsk.x+203,WAsk.y+WAsk.height-10,"",true,screen);
      }
   else
      button(WAsk.x+191,WAsk.y+WAsk.height-22,WAsk.x+203,WAsk.y+WAsk.height-10,"",false,screen);
   linegl(screen,WAsk.x+194,WAsk.y+WAsk.height-18,WAsk.x+197,WAsk.y+WAsk.height-15,0x00);
   linegl(screen,WAsk.x+194,WAsk.y+WAsk.height-17,WAsk.x+197,WAsk.y+WAsk.height-14,0x00);
   linegl(screen,WAsk.x+200,WAsk.y+WAsk.height-18,WAsk.x+197,WAsk.y+WAsk.height-15,0x00);
   linegl(screen,WAsk.x+200,WAsk.y+WAsk.height-17,WAsk.x+197,WAsk.y+WAsk.height-14,0x00);
                // Carré
   if(NbDir!=0&&NbDir>40)
      i=WAsk.y+63+DecD*(WAsk.height-97)/(NbDir-39);
   else
      i=WAsk.y+63;
   e=i+12;
   button(WAsk.x+191,i,WAsk.x+203,e,"",0x00,screen);
   if(mouse_b==1&&AMouseB==1&&NbDir>40
    &&mouse_y!=AMouseY
    &&AMouseX>=WAsk.x+191&&AMouseX<=WAsk.x+203
    &&mouse_x>=WAsk.x+191&&mouse_x<=WAsk.x+203
    &&mouse_y>=WAsk.y+63&&mouse_y<WAsk.y+WAsk.height-22) {
       i=mouse_y-6;
       DecD=(i-WAsk.y-63)*(NbDir-40)/(WAsk.height-97);
       if(DecD>NbDir-40) DecD=NbDir-40;
       if(DecD<0) DecD=0;
       }

show_mouse(screen);
algl_draw_mouse();
show_mouse(NULL);
   
allegro_gl_unset_allegro_mode();	// On repasse dans le mode précédent

allegro_gl_flip();

}while(done==0);

if(key==27) Name="";
if(key==13 && strrchr(Name.c_str(),'*')!=NULL) {
   Filter=strdup(Name.c_str());
   allegro_gl_unset_allegro_mode();
   goto detect;
   }

destroy_bitmap(Img);

while(keypressed())	{
	rest(1);
	readkey();
	}

return strdup((CurDir+"/"+Name).c_str());
}

/*---------------------------------------------------------------------------\
|               Affiche une fenêtre de demande de type oui/non               |
\---------------------------------------------------------------------------*/

bool WndAsk(char *Title,char *Msg,int ASW_TYPE)
{
	WND Popup;
	
	Popup.width=strlen(Msg)*8>300 ? strlen(Msg)*8+20: 320;
	Popup.height=60;
	Popup.x=(*screen).w-Popup.width>>1;	Popup.y=(*screen).h-Popup.height>>1;
	Popup.Lock=false;
	Popup.Title=Title;
	Popup.NbObj=3;
	Popup.Objets=(GUIOBJ*) malloc(sizeof(GUIOBJ)*Popup.NbObj);
			// Création des objets de la fenêtre
		// Message
	Popup.Objets[0].create_text(Popup.width-strlen(Msg)*8>>1,20,Msg);
		// Boutons OK/Oui et Annuler/Non
	if(ASW_TYPE==ASW_OKCANCEL){
		Popup.Objets[1].create_button(Popup.width/3-16,36,Popup.width/3+16,52,"OK",NULL);
		Popup.Objets[2].create_button(Popup.width*2/3-36,36,Popup.width*2/3+36,52,"Annuler",NULL);
		}
	else {
		Popup.Objets[1].create_button(Popup.width/3-20,36,Popup.width/3+20,52,"Oui",NULL);
		Popup.Objets[2].create_button(Popup.width*2/3-20,36,Popup.width*2/3+20,52,"Non",NULL);
		}

	int Popup_Done=0;
	
	int AMx=mouse_x,AMy=mouse_y,AMb=mouse_b;

	do
	{

		if(Popup.Objets[1].Etat) Popup_Done=1;
		if(Popup.Objets[2].Etat) Popup_Done=2;

		AMx=mouse_x;							// Mémorise l'ancien état de la souris
		AMy=mouse_y;
		AMb=mouse_b;

		poll_mouse();								// Obtient l'état de la souris
		
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Efface l'écran
		
		allegro_gl_set_allegro_mode();	// On repasse dans le mode dessin 2D pour Allegro

		Popup.check(AMx,AMy,AMb);	// Gestion de l'interface utilisateur graphique

		Popup.draw(screen);		// Dessine la boîte de dialogue

		algl_draw_mouse();			// Dessine le curseur

		allegro_gl_unset_allegro_mode();	// On repasse dans le mode précédent

		allegro_gl_flip();

	}while(Popup_Done==0);

	if(Popup_Done==1) return true;
	return false;
}

/*---------------------------------------------------------------------------\
|               Affiche une fenêtre Popup d'affichage d'infos                |
\---------------------------------------------------------------------------*/

void Popup(char *Title,char *Msg)
{
	WND Popup;
	
	Popup.width=strlen(Msg)*8>300 ? strlen(Msg)*8+20: 320;
	Popup.height=60;
	Popup.x=(*screen).w-Popup.width>>1;	Popup.y=(*screen).h-Popup.height>>1;
	Popup.Lock=false;
	Popup.Title=Title;
	Popup.NbObj=2;
	Popup.Objets=(GUIOBJ*) malloc(sizeof(GUIOBJ)*Popup.NbObj);
			// Création des objets de la fenêtre
		// Message
	Popup.Objets[0].create_text(Popup.width-strlen(Msg)*8>>1,20,Msg);
		// Boutons OK
	Popup.Objets[1].create_button(Popup.width/2-16,36,Popup.width/2+16,52,"OK",NULL);

	bool Popup_Done=false;
	
	int AMx=mouse_x,AMy=mouse_y,AMb=mouse_b;

	do
	{

		if(Popup.Objets[1].Etat) Popup_Done=true;

		AMx=mouse_x;							// Mémorise l'ancien état de la souris
		AMy=mouse_y;
		AMb=mouse_b;

		poll_mouse();								// Obtient l'état de la souris
		
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Efface l'écran
		
		allegro_gl_set_allegro_mode();	// On repasse dans le mode dessin 2D pour Allegro

		Popup.check(AMx,AMy,AMb);	// Gestion de l'interface utilisateur graphique

		Popup.draw(screen);		// Dessine la boîte de dialogue

		algl_draw_mouse();			// Dessine le curseur

		allegro_gl_unset_allegro_mode();	// On repasse dans le mode précédent

		allegro_gl_flip();

	}while(!Popup_Done);
}

/*---------------------------------------------------------------------------\
|               Affiche une fenêtre de demande d'entrée utilisateur          |
\---------------------------------------------------------------------------*/

char* GetVal(char *Title)
{
	char *Answ=(char*) malloc(101);
	Answ[0]=0;
	
	WND Popup;
	
	Popup.width=320;
	Popup.height=60;
	Popup.x=(*screen).w-Popup.width>>1;	Popup.y=(*screen).h-Popup.height>>1;
	Popup.Lock=false;
	Popup.Title=Title;
	Popup.NbObj=2;
	Popup.Objets=(GUIOBJ*) malloc(sizeof(GUIOBJ)*Popup.NbObj);
			// Création des objets de la fenêtre
		// Message
	Popup.Objets[0].create_textbar(10,20,310,34,Answ,100,NULL);
		// Boutons OK
	Popup.Objets[1].create_button(Popup.width/2-16,36,Popup.width/2+16,52,"OK",NULL);
	Popup.Objets[0].Focus=true;

	bool Popup_Done=false;
	
	int AMx=mouse_x,AMy=mouse_y,AMb=mouse_b;

	do
	{
		poll_mouse();
	}while(mouse_b!=0);

	do
	{

		if(Popup.Objets[1].Etat || Popup.Objets[0].Etat) Popup_Done=true;

		AMx=mouse_x;							// Mémorise l'ancien état de la souris
		AMy=mouse_y;
		AMb=mouse_b;

		poll_mouse();								// Obtient l'état de la souris
		
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Efface l'écran
		
		allegro_gl_set_allegro_mode();	// On repasse dans le mode dessin 2D pour Allegro

		Popup.check(AMx,AMy,AMb);	// Gestion de l'interface utilisateur graphique

		Popup.draw(screen);		// Dessine la boîte de dialogue

		algl_draw_mouse();			// Dessine le curseur

		allegro_gl_unset_allegro_mode();	// On repasse dans le mode précédent

		allegro_gl_flip();

	}while(!Popup_Done);

	return Answ;

}
