/*  TA3D, a remake of Total Annihilation
    Copyright (C) 2005  Roland BROCHARD

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

/*---------------------------------------------------------------------------------\
|                                        gui.h                                     |
|         Contient les fonctions nécessaires à la gestion de l'interface de ta3D   |
|  comme les boutons, les fenêtres,...                                             |
|                                                                                  |
\---------------------------------------------------------------------------------*/

#ifndef MODULE_GUI
#define MODULE_GUI

void glbutton(char *caption,float x1,float y1,float x2,float y2,bool etat=false);

char *msg_box(FONT *fnt,char *title,char *msg,bool ask);

//-------------- These are the GUI functions needed by the editors ----------------------------

		// Pour les couleurs standards

#define GrisM	makecol(128,128,128)
#define GrisF	makecol(64,64,64)
#define GrisC	makecol(192,192,192)
#define Noir	makecol(0,0,0)
#define Blanc	makecol(255,255,255)
#define Bleu	makecol(0,0,255)
#define Rouge	makecol(255,0,0)
#define Vert	makecol(0,255,0)
#define Jaune	makecol(255,255,0)
#define GrisCM	makecol(170,170,170)
#define RougeF	makecol(128,0,0)

		// Différents types d'objet
#define OBJ_BUTTON	0x0		// Boutton
#define OBJ_FMENU	0x1		// Menu flottant
#define OBJ_OPTIONB	0x2		// Boutton d'option
#define OBJ_PBAR	0x3		// Barre de progression
#define OBJ_TEXTBAR	0x4		// Barre d'entrée de texte
#define OBJ_OPTIONC	0x5		// Case à cocher
#define OBJ_MENU	0x6		// Menu déroulant  
#define OBJ_TEXT	0x7		// Affiche du texte

#define ASW_YESNO		0x0
#define ASW_OKCANCEL	0x1

struct wnd				// Pour la gestion directe de l'interface dans le programme
{
   int x,y;             //coordonnées
   int width,height;    //taille
   char *Title;         //nom
};

void button (int x,int y,int x2,int y2,char *Title,bool Etat,BITMAP *bmp);
void FloatMenu(int x,int y,char *Entry[],int NumEntry,BITMAP *bmp,int Index);
void OptionButton(int x,int y,char *Title,bool Etat,BITMAP *bmp);
void OptionCase(int x,int y,char *Title,bool Etat,BITMAP *bmp);
void TextBar(int x1,int y1,int x2,int y2,char *Caption,bool Etat,BITMAP *bmp);
void ProgressBar(int x1,int y1,int x2,int y2,int Value,BITMAP *bmp);
void rectdot(BITMAP *bmp,int x1,int y1,int x2,int y2,int col);
void draw_Window(wnd Wnd,BITMAP *bmp);
unsigned char WinMov(int AMx,int AMy,int AMb,int Mx,int My,int Mb,wnd *Wnd);
String dirname(String fname);
char * Dialog(char *Title,char *Filter="*.*");
bool WndAsk(char *Title,char *Msg,int ASW_TYPE=ASW_OKCANCEL);
void Popup(char *Title,char *Msg);
char* GetVal(char *Title);

extern FONT *gui_font;

inline void rectgl(BITMAP *bmp,int x1,int y1,int x2,int y2,int col)
{
	if(bmp==screen) {
		glBegin(GL_LINE_STRIP);
			glColor3f(getr(col)/255.0f,getg(col)/255.0f,getb(col)/255.0f);
			glVertex2i(x1,y1);
			glVertex2i(x2,y1);
			glVertex2i(x2,y2);
			glVertex2i(x1,y2);
			glVertex2i(x1,y1);
		glEnd();
		}
	else {
		line(bmp,x1,y1,x2,y1,col);
		line(bmp,x1,y1,x1,y2,col);
		line(bmp,x2,y1,x2,y2,col);
		line(bmp,x1,y2,x2,y2,col);
		}
}

inline void rectfillgl(BITMAP *bmp,int x1,int y1,int x2,int y2,int col)
{
	if(bmp==screen) {
		glBegin(GL_QUADS);
			glColor3f(getr(col)/255.0f,getg(col)/255.0f,getb(col)/255.0f);
			glVertex2i(x1,y1);
			glVertex2i(x2,y1);
			glVertex2i(x2,y2);
			glVertex2i(x1,y2);
		glEnd();
		}
	else {
		line(bmp,x1,y1,x2,y1,col);
		line(bmp,x1,y1,x1,y2,col);
		line(bmp,x2,y1,x2,y2,col);
		line(bmp,x1,y2,x2,y2,col);
		}
}

inline void linegl(BITMAP *bmp,int x1,int y1,int x2,int y2,int col)
{
	if(bmp==screen) {
		glBegin(GL_LINES);
			glColor3f(getr(col)/255.0f,getg(col)/255.0f,getb(col)/255.0f);
			glVertex2i(x1,y1);
			glVertex2i(x2,y2);
		glEnd();
		}
	else
		line(bmp,x1,y1,x2,y2,col);
}

inline void agl_textout(BITMAP *bmp,FONT *fnt,char *string,int x,int y,int col)
{
	if(col==0) {
		glEnable(GL_BLEND);
		glBlendFunc(GL_ONE_MINUS_SRC_COLOR,GL_ONE_MINUS_SRC_COLOR);
		allegro_gl_printf(fnt,x,y,0.0f,col,string);
		glDisable(GL_BLEND);
		}
	else {
		glEnable(GL_BLEND);
		glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_COLOR);
		allegro_gl_printf(fnt,x,y,0.0f,col,string);
		glDisable(GL_BLEND);
		}
}

class GUIOBJ					// Structure pour les objets contenus dans les fenêtres
{
public:
	byte Type;		// Type d'objet
	bool Focus;		// Séléctionné??
	bool Etat;		// Etat de l'objet
	int x1,y1;		// Position(dans la fenêtre)
	int x2,y2;
	char **Text;	// Texte affiché par l'objet
	int NString;	// Nombre de chaîne dans **Text
	void (*Func)(int);	// Pointeur sur la fonction associée à l'objet
	int Data;		// Données supplémentaires
	int Pos;		// Position sur une liste

	GUIOBJ()			// Initialise l'objet
	{
		Focus=false;
		Etat=false;
		Func=NULL;
		Data=0;
		Pos=0;
	}

				// Crée un bouton
	void create_button(int X1,int Y1,int X2,int Y2,char *Caption,void (*F)(int));
	void create_optionc(int X1,int Y1,char *Caption,bool ETAT,void (*F)(int));
	void create_optionb(int X1,int Y1,char *Caption,bool ETAT,void (*F)(int));
	void create_textbar(int X1,int Y1,int X2,int Y2,char *Caption,int MaxChar, void(*F)(int)=NULL);
	void create_menu(int X1,int Y1,char *Entry[],int NbEntry,void (*F)(int));
	void create_menu(int X1,int Y1,int X2,int Y2,char *Entry[],int NbEntry,void (*F)(int));
	void create_pbar(int X1,int Y1,int X2,int Y2,int PCent);
	void create_text(int X1,int Y1,char *Caption,int Col=0x0);
};

class WND						// Classe pour objet fenêtre
{
public:
   int x,y;             // coordonnées
   int width,height;    // taille
   char *Title;         // nom
   GUIOBJ *Objets;		// Objets contenus dans la fenêtre
   int NbObj;			// Nombre d'objets
   bool Lock;			// Fenêtre non déplaçable??

	WND()			// Constructeur
	{
		width=SCREEN_W>>1;
		height=SCREEN_H>>1;
		x=SCREEN_W>>2;
		y=SCREEN_H>>2;
		Title=NULL;
		NbObj=0;
		Objets=NULL;
		Lock=false;
	}

	void draw(BITMAP *bmp,bool Focus=true,bool Deg=true);
	unsigned char WinMov(int AMx,int AMy,int AMb,int Mx,int My,int Mb);
	int check(int AMx,int AMy,int AMb,bool timetoscroll=true);
};

#endif
