/*  TA3D, a remake of Total Annihilation
    Copyright (C) 2006  Roland BROCHARD

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include "stdafx.h"
#include "TA3D_NameSpace.h"
#include "hash_table.h"

using namespace std;
using namespace TA3D::UTILS;

#define __HASH_TABLE_SIZE	0x1000
#define __HASH_TABLE_MASK	0x0FFF

HASH_TABLE::HASH_TABLE()
{
	list<ELEMENT> empty_list;
	table.resize(__HASH_TABLE_SIZE,empty_list);
}

uint32 HASH_TABLE::return_hash(string key)
{
	uint32 hash=0;
	for(uint32 i=0;i<key.length();i++)
		hash=(hash<<5)-hash+key[i];
	return hash&__HASH_TABLE_MASK;
}

void *HASH_TABLE::find(string key)
{
	uint32 hash=return_hash(key);

	for(list<ELEMENT>::iterator cur = table[hash].begin() ; cur!=table[hash].end() ; cur++)
		if(key == cur->key)
			return cur->value;
	return NULL;
}

void HASH_TABLE::add(string key,void *value)
{
	uint32 hash=return_hash(key);

	ELEMENT elt;
	elt.key=key;
	elt.value=value;

	table[hash].push_back(elt);
}

void HASH_TABLE::erase(string key)
{
	uint32 hash=return_hash(key);

	list<ELEMENT>::iterator cur;

	for(cur=table[hash].begin();cur!=table[hash].end();cur++)
		if(cur->key == key) {
			table[hash].erase(cur);
			break;
			}
}
