/*  TA3D, a remake of Total Annihilation
    Copyright (C) 2005  Roland BROCHARD

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

/*-----------------------------------------------------------------------------\
|                                    menu.cpp                                  |
|       Ce module contient les routines du menu de TA3D                        |
|                                                                              |
\-----------------------------------------------------------------------------*/

#ifdef CWDEBUG
#include <libcwd/sys.h>
#include <libcwd/debug.h>
#endif
#include "stdafx.h"
#include "matrix.h"
#include "TA3D_NameSpace.h"
#include "ta3dbase.h"
#include "3do.h"					// Pour la lecture des fichiers 3D
#include "cob.h"					// Pour la lecture et l'éxecution des scripts
//#include "fbi.h"					// Pour la gestion des unités
#include "EngineClass.h"			// Inclus le moteur
#include "tnt.h"					// Inclus le chargeur de cartes
#include "menu.h"
#include "gui.h"
#include "taconfig.h"

#define size	20.0f

GLuint glfond;
FONT *allegro_font;
FONT *fnt;

void main_menu(void)
{
	set_mouse_range(0,0,639,479);

	allegro_font=ta_alfont;

	GLuint tex_formatA,tex_format;
	if(g_useTextureCompression) {
		tex_formatA=GL_COMPRESSED_RGBA_ARB;
		tex_format=GL_COMPRESSED_RGB_ARB;
		}
	else {
		tex_formatA=GL_RGBA8;
		tex_format=GL_RGB8;
		}

	fnt=ta_glfont;

	set_color_depth(32);
	allegro_gl_use_alpha_channel(false);
	BITMAP *bmp=load_bitmap("gfx/menu.jpg",NULL);
	glfond=allegro_gl_make_texture(bmp);
	glBindTexture(GL_TEXTURE_2D, glfond);
	allegro_gl_set_texture_format(tex_format);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	destroy_bitmap(bmp);

	bool done=false;

	allegro_gl_set_allegro_mode();

	ReInitTexSys();

	glScalef(SCREEN_W/640.0f,SCREEN_H/480.0f,1.0f);

	int i;

	float dt=0.0f;
	int time=Atimer;
	float Conv=1.0f/SECS_TO_TIMER(1);

	float h=text_height(allegro_font);

	BITMAP *tst[3];
	GLuint mnu[3];
	GLuint flame=LoadMaskedTex("gfx/fire.tga","gfx/firea.tga");
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	// pour les cartes ATI / for ATI cards which might not deal correctly with mipmap compressed textures here
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	mnu[0]=LoadTex("gfx/exit.tga");
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	mnu[1]=LoadTex("gfx/options.tga");
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	mnu[2]=LoadTex("gfx/play.tga");
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	tst[0]=load_bitmap("gfx/exit.tga",NULL);
	tst[1]=load_bitmap("gfx/options.tga",NULL);
	tst[2]=load_bitmap("gfx/play.tga",NULL);

	int px[3]={	320,	160,	480 };
	int py[3]={	400,	300,	300 };

	VECTOR part[100];
	for(i=0;i<100;i++) {
		part[i].x=-size;	part[i].y=-size;
		part[i].z=0.0f;
		}

	int n=0;

	cursor_type=CURSOR_DEFAULT;

	do
	{
		do
		{
			dt=(Atimer-time)*Conv;
			rest(1);
		}while(dt<0.01f);
		time=Atimer;

		if(key[KEY_ESC])	done=true;

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Efface l'écran

		PutTex(glfond,0.0f,0.0f,640.0f,480.0);

		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		allegro_gl_printf(fnt,320.0f-text_length(allegro_font,TA3D_ENGINE_VERSION)*0.5f,200.0f,0.0f,0xFFFFFF,TA3D_ENGINE_VERSION);

		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

		int index=-1;
		for(i=0;i<3;i++)
			for(int e=0;e<10;e+=2)
				if(px[i]-120-e<mouse_x && px[i]+120+e>mouse_x && py[i]-40-e<mouse_y && py[i]+40+e>mouse_y) {
					int rx=(mouse_x-(px[i]-120-e))*240/(240+2*e);
					int ry=(mouse_y-(py[i]-40-e))*80/(80+2*e);
					if(getpixel(tst[i],rx,ry)) {
						index=i;
						i=3;
						e=10;
						}
					}

		for(i=0;i<3;i++) {
			if(i==index)
				glBlendFunc(GL_ONE,GL_ONE);
			else
				glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
			for(int e=0;e<10;e+=2)
				PutTex(mnu[i],px[i]-120-e,py[i]-40-e,px[i]+120+e,py[i]+40+e);
			}
		glColor4f(1.0f,1.0f,1.0f,1.0f);

		glBlendFunc(GL_SRC_ALPHA,GL_ONE);
		switch(index)
		{
		case -1:
			part[n%100].x=-size;
			part[n%100].y=-size;
			break;
		case 0:
		case 1:
		case 2:
			part[n%100].x=px[index]+120.0f*cos(n*0.15f)+((rand()%2001)-1000)*0.01f;
			part[n%100].y=py[index]+40.0f*cos(n*0.255f)+((rand()%2001)-1000)*0.01f;
			break;
		};

		for(i=0;i<100;i++) {
			int d=100-((n-i)%100);
			glColor4f(d*0.01f,d*0.01f,d*0.01f,d*0.01f);
			glPushMatrix();
			glTranslatef(part[i].x,part[i].y,0.0f);
			glRotatef((i&1) ? n : -n,0.0f,0.0f,1.0f);
			glTranslatef(-part[i].x,-part[i].y,0.0f);
			PutTex(flame,part[i].x-size,part[i].y-size,part[i].x+size,part[i].y+size);
			glPopMatrix();
			}
		n++;
		glColor4f(1.0f,1.0f,1.0f,1.0f);

		glDisable(GL_BLEND);

		draw_cursor();

		if(mouse_b) {
			set_mouse_range(0,0,SCREEN_W-1,SCREEN_H-1);
			switch(index)
			{
			case 0:
				done=true;
				break;
			case 1:
				config_menu();
				break;
			case 2:
				{
				char *map_name=select_map();

				if(map_name) {
					allegro_gl_unset_allegro_mode();

					set_mouse_range(0,0,SCREEN_W-1,SCREEN_H-1);
					play(map_name);

					allegro_gl_set_allegro_mode();
					ReInitTexSys();
					glScalef(SCREEN_W/640.0f,SCREEN_H/480.0f,1.0f);
					}
				}
				break;
			};
			set_mouse_range(0,0,639,479);
			cursor_type=CURSOR_DEFAULT;		// Curseur par standard
			}

		allegro_gl_flip();
	}while(!done);

	destroy_bitmap(tst[0]);
	destroy_bitmap(tst[1]);
	destroy_bitmap(tst[2]);

	allegro_gl_unset_allegro_mode();

	glDeleteTextures(1,&flame);
	glDeleteTextures(1,&glfond);
	glDeleteTextures(1,&mnu[0]);
	glDeleteTextures(1,&mnu[1]);
	glDeleteTextures(1,&mnu[2]);
}

char *select_map(void)				// Cette fonction affiche un menu permettant à l'utilisateur de choisir une carte dans une liste et de la prévisualiser à l'écran
{
	set_mouse_range(0,0,639,479);

	bool done=false;

	allegro_gl_set_allegro_mode();

	ReInitTexSys();

	FONT *small_fnt = aglfont;

	set_uformat(U_ASCII);		// Juste histoire d'avoir un affichage correct des textes

	glScalef(SCREEN_W/640.0f,SCREEN_H/480.0f,1.0f);

	int i;

	float dt=0.0f;
	int time=Atimer;
	float Conv=1.0f/SECS_TO_TIMER(1);

	float h=text_height(allegro_font);
	float data_h = 24.0f;

	list<string> map_list;
	uint32 n = HPIManager->GetFilelist("maps\\*.tnt",&map_list);
	list<string>::iterator i_map;

	char *choice=NULL;

	for(i_map=map_list.begin();i_map!=map_list.end();i_map++) {						// Nettoie la liste des cartes (enlève les préfixes "/maps/" et l'extension)
		for(i=0;i<i_map->length();i++)
			if((*i_map)[i]=='.') {
				i_map->resize(i);
				break;
				}
		*i_map=i_map->substr(5,i_map->length()-5);
		}

	map_list.sort();
 
	int dec=0;			// Pour la gestion de la liste déroulante
	int amz=mouse_z;
	int o_sel=-1;
	int sel_index=0;
	int index=-1;
	int m_timer=Atimer;

	bool dmini=false;		// Pour la minimap
	GLuint mini;
	int dx=0;
	int dy=0;

	bool ok_status=false;		// Pour les boutons
	bool cancel_status=false;
	bool o_ok_status=false;
	bool o_cancel_status=false;

	MAP_OTA	map_data;

	do
	{
		do
		{
			dt=(Atimer-time)*Conv;
			rest(1);
		}while(dt<0.02f);
		time=Atimer;

		o_ok_status=ok_status;
		o_cancel_status=cancel_status;
		ok_status=false;
		cancel_status=false;
		if(mouse_b==1 && mouse_y>=440 && mouse_y<=460) {
			ok_status=(mouse_x>=360 && mouse_x<=440);
			cancel_status=(mouse_x>=520 && mouse_x<=600);
			}

		if(mouse_b==0 && !ok_status && o_ok_status) {		// Click sur ok
			if(sel_index!=-1) {
				done=true;
				i_map=map_list.begin();
				for(i=0;i<sel_index && i_map!=map_list.end();i++)	i_map++;
				string tmp = string("maps\\") + *i_map + string(".tnt");
				choice=strdup(tmp.c_str());		// Copie le nom de la carte sélectionnée
				}
			}
		if(mouse_b==0 && !cancel_status && o_cancel_status)			// Click sur retour
			done=true;

		if(key[KEY_ESC]) {
			while(key[KEY_ESC])
				rest(1);
			done=true;
			}
		if(key[KEY_ENTER]) {
			if(sel_index!=-1) {
				done=true;
				i_map=map_list.begin();
				for(i=0;i<sel_index && i_map!=map_list.end();i++)	i_map++;
				string tmp = string("maps\\") + *i_map + string(".tnt");
				choice=strdup(tmp.c_str());		// Copie le nom de la carte sélectionnée
				}
			}
		bool check=false;
		if((Atimer-m_timer)*Conv>=0.1f) {
			if(key[KEY_DOWN])	{	sel_index++;	m_timer=Atimer;	check=true;	}
			if(key[KEY_UP])		{	sel_index--;	m_timer=Atimer;	check=true;	}
			if(o_sel!=sel_index && sel_index==-1)	sel_index=0;
			if(sel_index<-1)	sel_index=-1;
			if(sel_index>=n)	sel_index=n-1;
			}

		if(check) {
			if(sel_index>=dec+(int)(440.0f/h)-1)
				dec=sel_index-(int)(440.0f/h)+1;
			if(sel_index>=0 && sel_index<dec)
				dec=sel_index;
			}

		dec+=amz-mouse_z;
		if((Atimer-m_timer)*Conv>=0.2f) {
			if(mouse_x>=15.0f && mouse_x<320.0f && mouse_y>=30.0f && mouse_y<30.0f+h) {
				m_timer=Atimer;
				dec--;
				}
			if(mouse_x>=15.0f && mouse_x<320.0f && mouse_y>=470.0f-h && mouse_y<470.0f) {
				m_timer=Atimer;
				dec++;
				}
			}
		if(dec<0) dec=0;
		if(dec>n+1-440.0f/h) dec=(int)(n+1-440.0f/h);
		amz=mouse_z;

		if(mouse_x>=15.0f && mouse_x<320.0f && mouse_y>=30.0f && mouse_y<470.0f) {
			index=(int)((mouse_y-30.0f)/h+dec);
			if(index>=n) index=-1;		// On ne sort pas de l'intervalle fixé
			if(mouse_b==1)
				sel_index=index;
			}
		else
			index=-1;

		if(sel_index!=o_sel && sel_index>=0) {
			if(dmini)
				glDeleteTextures(1,&mini);
			i_map=map_list.begin();
			for(i=0;i<sel_index && i_map!=map_list.end();i++)	i_map++;
			string tmp=string("maps\\") + *i_map + string(".tnt");
			mini=load_tnt_minimap_fast((char*)tmp.c_str(),&dx,&dy);
			dmini=(mini!=0);
			tmp=string("maps\\") + *i_map + string(".ota");								// Read the ota file
			uint32 ota_size=0;
			byte *data = HPIManager->PullFromHPI(tmp,&ota_size);
			if(data) {
				map_data.load((char*)data,ota_size);
				free(data);
				}
			else
				map_data.destroy();
			}

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Efface l'écran

		glColor4f(1.0f,1.0f,1.0f,1.0f);
		PutTex(glfond,0.0f,0.0f,640.0f,480.0);

		glDisable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(0.0f,0.0f,0.0f,0.5f);
		glBegin(GL_QUADS);
			glVertex2f(10.0f,25.0f);
			glVertex2f(630.0f,25.0f);
			glVertex2f(630.0f,470.0f);
			glVertex2f(10.0f,470.0f);
		glEnd();
		glColor4f(1.0f,1.0f,1.0f,0.5f);
		glBegin(GL_LINE_LOOP);
			glVertex2f(10.0f,25.0f);
			glVertex2f(630.0f,25.0f);
			glVertex2f(630.0f,470.0f);
			glVertex2f(10.0f,470.0f);
		glEnd();
		glBegin(GL_LINE_LOOP);
			glVertex2f(347.0f,50.0f);
			glVertex2f(603.0f,50.0f);
			glVertex2f(603.0f,306.0f);
			glVertex2f(347.0f,306.0f);
		glEnd();
		glBegin(GL_LINES);
			glVertex2f(320.0f,26.0f);
			glVertex2f(320.0f,469.0f);
		glEnd();
		glEnable(GL_TEXTURE_2D);

		glColor4f(1.0f,1.0f,1.0f,1.0f);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		allegro_gl_printf(fnt,320.0f-text_length(allegro_font,translation_manager.get(15))*0.5f,0.0f,0.0f,0xFFFFFF,translation_manager.get(15));

		i=0;
		for(i_map=map_list.begin();i_map!=map_list.end();i_map++) {
			if(30.0f+h*(i-dec)<470.0f-h && h*(i-dec)>=0) {
				if(i==index || i==sel_index) {
					glDisable(GL_TEXTURE_2D);
					glEnable(GL_BLEND);
					glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
					glBegin(GL_QUADS);
						if(i==sel_index)
							glColor4f(0.0f,0.0f,0.5f,0.5f);
						else
							glColor4f(0.25f,0.25f,0.5f,0.5f);
						glVertex2f(15.0f,30.0f+h*(i-dec));
						glVertex2f(319.0f,30.0f+h*(i-dec));
						if(i==sel_index)
							glColor4f(0.0f,0.0f,1.0f,0.5f);
						else
							glColor4f(0.5f,0.5f,1.0f,0.5f);
						glVertex2f(319.0f,30.0f+h*(i-dec+0.5f));
						glVertex2f(15.0f,30.0f+h*(i-dec+0.5f));

						glVertex2f(15.0f,30.0f+h*(i-dec+0.5f));
						glVertex2f(319.0f,30.0f+h*(i-dec+0.5f));
						if(i==sel_index)
							glColor4f(0.0f,0.0f,0.5f,0.5f);
						else
							glColor4f(0.25f,0.25f,0.5f,0.5f);
						glVertex2f(319.0f,30.0f+h*(i-dec+1));
						glVertex2f(15.0f,30.0f+h*(i-dec+1));
					glEnd();
					glColor4f(1.0f,1.0f,1.0f,0.5f);
					glEnable(GL_TEXTURE_2D);
					glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
					}
				allegro_gl_printf(fnt,20.0f,30.0f+h*(i-dec),0.0f,0xFFFFFF,i_map->c_str());
				}
			i++;
			}

		glColor4f(1.0f,1.0f,1.0f,1.0f);

		glDisable(GL_BLEND);

		if(dmini) {
			glBindTexture(GL_TEXTURE_2D,mini);
			float ldx=dx*256.0f/252.0f*0.5f;
			float ldy=dy*256.0f/252.0f*0.5f;
			glBegin(GL_QUADS);

				glTexCoord2f(0.0f,0.0f);
				glVertex2f(475.0f-ldx,178.0f-ldy);

				glTexCoord2f(dx/252.0f,0.0f);
				glVertex2f(475.0f+ldx,178.0f-ldy);
					
				glTexCoord2f(dx/252.0f,dy/252.0f);
				glVertex2f(475.0f+ldx,178.0f+ldy);
			
				glTexCoord2f(0.0f,dy/252.0f);
				glVertex2f(475.0f-ldx,178.0f+ldy);

			glEnd();
			}
		glColor4f(1.0f,1.0f,1.0f,1.0f);
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

		if(map_data.missionname)
			allegro_gl_printf(fnt,480.0f-text_length(fnt,map_data.missionname)*0.5f,320.0f,0.0f,0xFFFFFF,map_data.missionname);
		if(map_data.missiondescription) {
			glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_ALPHA);
			if(strstr(map_data.missiondescription,"\n")) {
				char *rem=strstr(map_data.missiondescription,"\n");
				rem[0]=0;
				allegro_gl_printf(small_fnt,340.0f,320.0f+data_h+3.0f,0.0f,0xFFFFFF,map_data.missiondescription);
				rem[0]='\n';
				if(strstr(rem+1,"\n")) {
					rem=strstr(rem+1,"\n");
					rem[0]=0;
					allegro_gl_printf(small_fnt,340.0f,320.0f+data_h+13.0f,0.0f,0xFFFFFF,rem+1);
					rem[0]='\n';
					allegro_gl_printf(small_fnt,340.0f,320.0f+data_h+23.0f,0.0f,0xFFFFFF,rem+1);
					}
				else
					allegro_gl_printf(small_fnt,340.0f,320.0f+data_h+13.0f,0.0f,0xFFFFFF,rem+1);
				}
			else
				allegro_gl_printf(small_fnt,340.0f,320.0f+data_h,0.0f,0xFFFFFF,map_data.missiondescription);
			glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
			}
		if(map_data.numplayers) {
			float len=(text_length(fnt,translation_manager.get(31))+text_length(fnt,map_data.numplayers))*0.5f;
			allegro_gl_printf(fnt,480.0f-len,320.0f+data_h*3.0f,0.0f,0xFFFFFF,translation_manager.get(31));
			allegro_gl_printf(fnt,480.0f-len+text_length(fnt,translation_manager.get(31)),320.0f+data_h*3.0f,0.0f,0xFFFFFF,map_data.numplayers);
			}

		o_sel=sel_index;

		glDisable(GL_BLEND);

		glbutton(translation_manager.get(16),360.0f,440.0f,440.0f,460.0f,ok_status);
		glbutton(translation_manager.get(17),520.0f,440.0f,600.0f,460.0f,cancel_status);

		draw_cursor();

		allegro_gl_flip();
	}while(!done);

	if(dmini)
		glDeleteTextures(1,&mini);

	allegro_gl_unset_allegro_mode();

	set_uformat(U_UTF8);

	return choice;
}

void config_menu(void)
{
	set_mouse_range(0,0,639,479);

	TA3D_CONFIG	config_manager;
	config_manager.set_config_file("ta3d.cfg");
	config_manager.add_option("showfps",true,false,NULL);
	config_manager.add_option("fps_limit",false,true,NULL);
	config_manager.add_option("wireframe",true,false,NULL);
	config_manager.add_option("particle",true,false,NULL);
	config_manager.add_option("trees",true,false,NULL);
	config_manager.add_option("shadow",true,false,NULL);
	config_manager.add_option("shadow_quality",false,false,NULL);
	config_manager.add_option("shadow_r",false,true,NULL);
	config_manager.add_option("priority_level",false,false,NULL);
	config_manager.add_option("timefactor",false,true,NULL);
	config_manager.add_option("screen_width",false,false,NULL);
	config_manager.add_option("screen_height",false,false,NULL);
	config_manager.add_option("fullscreen",true,false,NULL);
	config_manager.add_option("fsaa",false,false,NULL);
	config_manager.add_option("water_quality",false,false,NULL);
	config_manager.add_option("LANG",false,false,&LANG);
	config_manager.add_option("height_line",true,false,NULL);
	config_manager.read_config_file();

	bool done=false;

	allegro_gl_set_allegro_mode();

	ReInitTexSys();

	glScalef(SCREEN_W/640.0f,SCREEN_H/480.0f,1.0f);

	int i;

	float dt=0.0f;
	int time=Atimer;
	float Conv=1.0f/SECS_TO_TIMER(1);

	float h=text_height(allegro_font);
	int	amb=mouse_b;

	bool save=false;

	bool ok_status=false;		// Pour les boutons
	bool cancel_status=false;
	bool o_ok_status=false;
	bool o_cancel_status=false;
	int dec=0;
	int max_opts=(int)(400/h)+1;
	int amz=mouse_z;

	do
	{
		do
		{
			dt=(Atimer-time)*Conv;
			rest(1);
		}while(dt<0.02f);
		time=Atimer;

		if(key[KEY_ESC]) {
			while(key[KEY_ESC])
				rest(1);
			done=true;
			}

		o_ok_status=ok_status;
		o_cancel_status=cancel_status;
		ok_status=false;
		cancel_status=false;
		if(mouse_b==1 && mouse_y>=440 && mouse_y<=460) {
			ok_status=(mouse_x>=440 && mouse_x<=520);
			cancel_status=(mouse_x>=120 && mouse_x<=200);
			}

		if(mouse_b==0 && !ok_status && o_ok_status) {		// Click sur ok
			done=true;
			save=true;
			}
		if(mouse_b==0 && !cancel_status && o_cancel_status)			// Click sur retour
			done=true;

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Efface l'écran

		glColor4f(1.0f,1.0f,1.0f,1.0f);
		PutTex(glfond,0.0f,0.0f,640.0f,480.0);

		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glEnable(GL_BLEND);
		allegro_gl_printf(fnt,320.0f-0.5f*text_length(fnt,translation_manager.get(18)),8.0f,0.0f,0xFFFFFF,translation_manager.get(18));
		for(int i=0;i<min(config_manager.nb_options,max_opts);i++) {		// affiche les options
			int e=i+dec;
			allegro_gl_printf(fnt,32.0f,32.0f+i*h,0.0f,0xFFFFFF,config_manager.options[e].name);
			char buf[100];
			if(config_manager.options[e].boolean)
				uszprintf(buf,100,"%s",config_manager.get_option(e) ? "on" : "off");
			else if(config_manager.options[e].floatting)
				uszprintf(buf,100,"%f",config_manager.get_option(e));
			else
				uszprintf(buf,100,"%d",(int)config_manager.get_option(e));
			allegro_gl_printf(fnt,600.0f-text_length(fnt,buf),32.0f+i*h,0.0f,0xFFFFFF,buf);
			}

		glDisable(GL_BLEND);
		glbutton(translation_manager.get(16),440.0f,440.0f,520.0f,460.0f,ok_status);
		glbutton(translation_manager.get(21),120.0f,440.0f,200.0f,460.0f,cancel_status);

		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		if(mouse_x>=32 && mouse_x<=600 && mouse_y>=32 && mouse_y<32+h*min(config_manager.nb_options,max_opts)) {
			int idx=(int)((mouse_y-32)/h);
			glDisable(GL_TEXTURE_2D);
			glBegin(GL_QUADS);
				glColor4f(0.5f,0.5f,1.0f,0.0f);
				glVertex2f(32.0f,32.0f+idx*h);
				glVertex2f(600.0f,32.0f+idx*h);
				glColor4f(0.5f,0.5f,1.0f,0.5f);
				glVertex2f(600.0f,32.0f+(idx+0.5f)*h);
				glVertex2f(32.0f,32.0f+(idx+0.5f)*h);

				glVertex2f(32.0f,32.0f+(idx+0.5f)*h);
				glVertex2f(600.0f,32.0f+(idx+0.5f)*h);
				glColor4f(0.5f,0.5f,1.0f,0.0f);
				glVertex2f(600.0f,32.0f+(idx+1)*h);
				glVertex2f(32.0f,32.0f+(idx+1)*h);
			glEnd();
			glEnable(GL_TEXTURE_2D);
			glColor4f(1.0f,1.0f,1.0f,1.0f);
			idx+=dec;
			if(mouse_b==1 && amb==0) {
				if(config_manager.options[idx].boolean)
					config_manager.set_option(config_manager.options[idx].name,config_manager.get_option(idx)==1.0f ? 0.0f : 1.0f);
				else {
					char titre[100],msg[100];
					uszprintf(titre,100,translation_manager.get(19),config_manager.options[idx].name);
					uszprintf(msg,100,translation_manager.get(20),config_manager.options[idx].name);
					char *ans=msg_box(fnt,titre,msg,true);
					config_manager.set_option(config_manager.options[idx].name,atof(ans));
					free(ans);
					switch(idx)
					{
					case 1:			// fps_limit
						if(config_manager.get_option(idx)==0.0f)
							config_manager.set_option(config_manager.options[idx].name,-1.0f);
						break;
					case 6:			// shadow_quality
						if(config_manager.get_option(idx)<=0.0f)
							config_manager.set_option(config_manager.options[idx].name,1.0f);
						else if(config_manager.get_option(idx)>12.0f)
							config_manager.set_option(config_manager.options[idx].name,12.0f);
						break;
					case 7:			// shadow_r
						if(config_manager.get_option(idx)<0.0f)
							config_manager.set_option(config_manager.options[idx].name,0.0f);
						else if(config_manager.get_option(idx)>100.0f)
							config_manager.set_option(config_manager.options[idx].name,100.0f);
						break;
					case 8:			// priority_level
						if(config_manager.get_option(idx)<0.0f)
							config_manager.set_option(config_manager.options[idx].name,0.0f);
						else if(config_manager.get_option(idx)>2.0f)
							config_manager.set_option(config_manager.options[idx].name,2.0f);
						break;
					case 9:			// timefactor
						if(config_manager.get_option(idx)<=0.0f)
							config_manager.set_option(config_manager.options[idx].name,1.0f);
						else if(config_manager.get_option(idx)>10.0f)
							config_manager.set_option(config_manager.options[idx].name,10.0f);
						break;
					case 10:		// screen_width
						if(config_manager.get_option(idx)<=0.0f)
							config_manager.set_option(config_manager.options[idx].name,1.0f);
						break;
					case 11:		// screen_height
						if(config_manager.get_option(idx)<=0.0f)
							config_manager.set_option(config_manager.options[idx].name,1.0f);
						break;
					case 14:		// water_quality
						if(config_manager.get_option(idx)<0.0f)
							config_manager.set_option(config_manager.options[idx].name,0.0f);
						else if(config_manager.get_option(idx)>3.0f)
							config_manager.set_option(config_manager.options[idx].name,3.0f);
						break;
					};
					}
				}
			}
		amb=mouse_b;

		glDisable(GL_BLEND);

		if(max_opts<config_manager.nb_options) {
			glDisable(GL_TEXTURE_2D);
			glBegin(GL_QUADS);
				glColor3f(0.4f,0.4f,0.8f);
				glVertex2i(4,32);
				glVertex2i(28,32);

				glColor3f(0.2f,0.2f,0.4f);
				glVertex2i(28,440);
				glVertex2i(4,440);
			glEnd();
			int pos = 32 + dec*376/(config_manager.nb_options-max_opts);
			glBegin(GL_QUADS);
				glColor3f(0.8f,0.4f,0.4f);
				glVertex2i(4,pos);
				glVertex2i(28,pos);
				glColor3f(0.4f,0.2f,0.2f);
				glVertex2i(28,32+pos);
				glVertex2i(4,32+pos);
			glEnd();
			if(mouse_x>=4 && mouse_x<=28 && mouse_y>=32 && mouse_y<440 && mouse_b==1)
				dec=((mouse_y-48)*(config_manager.nb_options-max_opts)+188)/376;
			else
				dec+=amz-mouse_z;
			amz=mouse_z;
			if(dec<0)	dec=0;
			if(dec+max_opts>config_manager.nb_options)	dec=config_manager.nb_options-max_opts;
			}

		glEnable(GL_TEXTURE_2D);
		glColor3f(1.0f,1.0f,1.0f);

		draw_cursor();

		allegro_gl_flip();
	}while(!done);

	if(save)
		config_manager.write_config_file();

	allegro_gl_unset_allegro_mode();
}

void stats_menu(void)
{
	set_mouse_range(0,0,639,479);

	cursor_type=CURSOR_DEFAULT;

	bool done=false;

	allegro_gl_set_allegro_mode();

	ReInitTexSys();

	glScalef(SCREEN_W/640.0f,SCREEN_H/480.0f,1.0f);

	int i;

	float dt=0.0f;
	int time=Atimer;
	float Conv=1.0f/SECS_TO_TIMER(1);

	if(allegro_font==NULL) {
		allegro_font=ta_alfont;
		fnt=ta_glfont;

		GLuint tex_formatA,tex_format;
		if(g_useTextureCompression) {
			tex_formatA=GL_COMPRESSED_RGBA_ARB;
			tex_format=GL_COMPRESSED_RGB_ARB;
			}
		else {
			tex_formatA=GL_RGBA8;
			tex_format=GL_RGB8;
			}

		set_color_depth(32);
		allegro_gl_use_alpha_channel(false);
		BITMAP *bmp=load_bitmap("gfx/menu.jpg",NULL);
		glfond=allegro_gl_make_texture(bmp);
		glBindTexture(GL_TEXTURE_2D, glfond);
		allegro_gl_set_texture_format(tex_format);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		destroy_bitmap(bmp);
		}

	float h=text_height(allegro_font);
	int	amb=mouse_b;

	bool ok_status=false;		// Pour les boutons
	bool o_ok_status=false;
	int amz=mouse_z;

	while(key[KEY_ESC])	rest(1);

	do
	{
		do
		{
			dt=(Atimer-time)*Conv;
			rest(1);
		}while(dt<0.02f);
		time=Atimer;

		if(key[KEY_ESC]) {
			while(key[KEY_ESC])
				rest(1);
			done=true;
			}

		o_ok_status=ok_status;
		ok_status=false;
		if(mouse_b==1 && mouse_y>=440 && mouse_y<=460)
			ok_status=(mouse_x>=240 && mouse_x<=400);

		if(mouse_b==0 && !ok_status && o_ok_status)		// Click sur ok
			done=true;

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Efface l'écran

		glColor4f(1.0f,1.0f,1.0f,1.0f);
		PutTex(glfond,0.0f,0.0f,640.0f,480.0f);

		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glEnable(GL_BLEND);
		allegro_gl_printf(fnt,320.0f-0.5f*text_length(fnt,translation_manager.get(32)),8.0f,0.0f,0xFFFFFF,translation_manager.get(32));

		glDisable(GL_TEXTURE_2D);

		glColor4f(0.0f,0.0f,0.0f,0.5f);
		glBegin(GL_QUADS);
			glVertex2i(8,32);
			glVertex2i(632,32);
			glVertex2i(632,432);
			glVertex2i(8,432);
		glEnd();

		glDisable(GL_BLEND);
		glColor4f(1.0f,1.0f,1.0f,1.0f);
		glBegin(GL_LINE_STRIP);
			glVertex2i(8,32);
			glVertex2i(632,32);
			glVertex2i(632,432);
			glVertex2i(8,432);
			glVertex2i(8,32);
		glEnd();

		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(0.5f,0.5f,0.5f,0.5f);
		glBegin(GL_LINES);
		for(int i=0;i<10;i++) {
			glVertex2i(32,72+36*i);
			glVertex2i(608,72+36*i);
			}
		glColor4f(1.0f,1.0f,1.0f,0.5f);
			glVertex2i(240,48);		glVertex2i(240,424);
			glVertex2i(318,48);		glVertex2i(318,424);
			glVertex2i(396,48);		glVertex2i(396,424);
			glVertex2i(474,48);		glVertex2i(474,424);
			glVertex2i(552,48);		glVertex2i(552,424);
		glEnd();
		glEnable(GL_TEXTURE_2D);

		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		allegro_gl_printf(fnt,136.0f-0.5f*text_length(fnt,translation_manager.get(33)),48.0f,0.0f,0xFFFFFF,translation_manager.get(33));
		allegro_gl_printf(fnt,276.0f-0.5f*text_length(fnt,translation_manager.get(34)),48.0f,0.0f,0xFFFFFF,translation_manager.get(34));
		allegro_gl_printf(fnt,354.0f-0.5f*text_length(fnt,translation_manager.get(35)),48.0f,0.0f,0xFFFFFF,translation_manager.get(35));
		allegro_gl_printf(fnt,432.0f-0.5f*text_length(fnt,translation_manager.get(36)),48.0f,0.0f,0xFFFFFF,translation_manager.get(36));
		allegro_gl_printf(fnt,510.0f-0.5f*text_length(fnt,translation_manager.get(37)),48.0f,0.0f,0xFFFFFF,translation_manager.get(37));
		allegro_gl_printf(fnt,588.0f-0.5f*text_length(fnt,translation_manager.get(38)),48.0f,0.0f,0xFFFFFF,translation_manager.get(38));

		for(int i=0;i<players.nb_player;i++) {
			char txt[100];
			float y=72.0f+18.0f-h*0.5f+36.0f*i;
			allegro_gl_printf(fnt,32.0f,y,0.0f,0xFFFFFF,players.nom[i]);
			allegro_gl_printf(fnt,276.0f-0.5f*text_length(fnt,players.side[i]),y,0.0f,0xFFFFFF,players.side[i]);
			uszprintf(txt,100,"%d",players.losses[i]);					allegro_gl_printf(fnt,354.0f-0.5f*text_length(fnt,txt),y,0.0f,0xFFFFFF,txt);
			uszprintf(txt,100,"%d",players.kills[i]);					allegro_gl_printf(fnt,432.0f-0.5f*text_length(fnt,txt),y,0.0f,0xFFFFFF,txt);
			uszprintf(txt,100,"%d",(int)players.energy_total[i]);		allegro_gl_printf(fnt,510.0f-0.5f*text_length(fnt,txt),y,0.0f,0xFFFFFF,txt);
			uszprintf(txt,100,"%d",(int)players.metal_total[i]);		allegro_gl_printf(fnt,588.0f-0.5f*text_length(fnt,txt),y,0.0f,0xFFFFFF,txt);
			}

		glDisable(GL_BLEND);
		glbutton(translation_manager.get(16),240.0f,440.0f,400.0f,460.0f,ok_status);

		amb=mouse_b;

		glEnable(GL_TEXTURE_2D);
		glColor3f(1.0f,1.0f,1.0f);

		draw_cursor();

		allegro_gl_flip();
	}while(!done);

	allegro_gl_unset_allegro_mode();
}

void battle_room(void)				// Let players create/join a game
{
	set_mouse_range(0,0,639,479);

	bool done=false;

	allegro_gl_set_allegro_mode();

	ReInitTexSys();

	FONT *small_fnt = aglfont;

	set_uformat(U_ASCII);		// Juste histoire d'avoir un affichage correct des textes

	glScalef(SCREEN_W/640.0f,SCREEN_H/480.0f,1.0f);

//	Network	TA3D_network;
//	TA3D_network.HostGame("my_game","1234",2,0);

	std::list<String>	servers;					// the server list
	std::list<String>::iterator	l_s_servers;		// iterator to read the server list
	servers.push_front(translation_manager.get(41));

	int i;

	float dt=0.0f;
	int time=Atimer;
	float Conv=1.0f/SECS_TO_TIMER(1);

	float h=text_height(allegro_font);

	bool ok_status=false;		// Pour les boutons
	bool cancel_status=false;
	bool o_ok_status=false;
	bool o_cancel_status=false;

	do
	{
		do
		{
			dt=(Atimer-time)*Conv;
			rest(1);
		}while(dt<0.02f);
		time=Atimer;

		o_ok_status=ok_status;
		o_cancel_status=cancel_status;
		ok_status=false;
		cancel_status=false;
		if(mouse_b==1 && mouse_y>=440 && mouse_y<=460) {
			ok_status=(mouse_x>=360 && mouse_x<=440);
			cancel_status=(mouse_x>=520 && mouse_x<=600);
			}

		if(mouse_b==0 && !ok_status && o_ok_status) {		// Click sur ok
			done=true;
			}
		if(mouse_b==0 && !cancel_status && o_cancel_status)			// Click sur retour
			done=true;

		if(key[KEY_ESC]) {
			while(key[KEY_ESC])
				rest(1);
			done=true;
			}
		if(key[KEY_ENTER])
			done=true;
		bool check=false;

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Efface l'écran

		glColor4f(1.0f,1.0f,1.0f,1.0f);
		PutTex(glfond,0.0f,0.0f,640.0f,480.0);

		glDisable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(0.0f,0.0f,0.0f,0.5f);
		glBegin(GL_QUADS);
			glVertex2f(10.0f,25.0f);
			glVertex2f(630.0f,25.0f);
			glVertex2f(630.0f,470.0f);
			glVertex2f(10.0f,470.0f);
		glEnd();
		glColor4f(1.0f,1.0f,1.0f,0.5f);
		glBegin(GL_LINE_LOOP);
			glVertex2f(10.0f,25.0f);
			glVertex2f(630.0f,25.0f);
			glVertex2f(630.0f,470.0f);
			glVertex2f(10.0f,470.0f);
		glEnd();
		glBegin(GL_LINE_LOOP);
			glVertex2f(347.0f,50.0f);
			glVertex2f(603.0f,50.0f);
			glVertex2f(603.0f,306.0f);
			glVertex2f(347.0f,306.0f);
		glEnd();
		glBegin(GL_LINES);
			glVertex2f(320.0f,26.0f);
			glVertex2f(320.0f,469.0f);
			glVertex2f(10.0f,32.0f+h);
			glVertex2f(320.0f,32.0f+h);
		glEnd();
		glEnable(GL_TEXTURE_2D);

		glColor4f(1.0f,1.0f,1.0f,1.0f);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		allegro_gl_printf(fnt,320.0f-text_length(allegro_font,translation_manager.get(39))*0.5f,0.0f,0.0f,0xFFFFFF,translation_manager.get(39));
		allegro_gl_printf(fnt,165.0f-text_length(allegro_font,translation_manager.get(40))*0.5f,32.0f,0.0f,0xFFFFFF,translation_manager.get(40));

		glColor4f(1.0f,1.0f,1.0f,1.0f);

		int i=0;
		for(l_s_servers=servers.begin();l_s_servers!=servers.end();l_s_servers++) {
			allegro_gl_printf(fnt,20.0f,h*i+64.0f,0.0f,0xFFFFFF,l_s_servers->c_str());
			i++;
			}

		glDisable(GL_BLEND);

		glColor4f(1.0f,1.0f,1.0f,1.0f);
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

		glDisable(GL_BLEND);

		glbutton(translation_manager.get(16),360.0f,440.0f,440.0f,460.0f,ok_status);
		glbutton(translation_manager.get(17),520.0f,440.0f,600.0f,460.0f,cancel_status);

		draw_cursor();

		allegro_gl_flip();
	}while(!done);

	allegro_gl_unset_allegro_mode();

	set_uformat(U_UTF8);
}
